unit MainFormUnit;

interface

uses
  Windows,SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QMenus, QComCtrls, QExtCtrls, Math, Registry, QGrids,
  xdspapi;

Const
  VERSION=2.00;

Const
  ADCBufLen=XDSP_BOARD_MEMORY-1; // Maximum ADC Buffer Length

// Types for ADC Arrays
type
  TA=^TArray;
  TArray=array[0..ADCBufLen] of Integer;
  TRealA=^TRealArray;
  TRealArray=array[0..ADCBufLen] of Double;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    DevicesMenu: TMenuItem;
    FileLoad: TMenuItem;
    StartButton: TButton;
    StopButton: TButton;
    PropPageControl: TPageControl;
    ViewTab: TTabSheet;
    SynchroTab: TTabSheet;
    MinMaxTab: TTabSheet;
    DiagTab: TTabSheet;
    DACTab: TTabSheet;
    DevicePageControl: TPageControl;
    ModelTab: TTabSheet;
    SignalPanel: TPanel;
    SignalsPageControl: TPageControl;
    SignalTab: TTabSheet;
    SigDACTab: TTabSheet;
    SigStatisticTab: TTabSheet;
    SignalPaintBox: TPaintBox;
    RefreshTimer: TTimer;
    StatusPanel: TPanel;
    ViewChannelPanel: TPanel;
    SamplingPanel: TPanel;
    ViewChannelRadioGroup: TRadioGroup;
    Channel1RadioButton: TRadioButton;
    Channel2RadioButton: TRadioButton;
    Channel12RadioButton: TRadioButton;
    ChannelSubRadioButton: TRadioButton;
    SamplingRadioGroup: TRadioGroup;
    CyclicalRadioButton: TRadioButton;
    OnetimeRadioButton: TRadioButton;
    BankSelectPanel: TPanel;
    BankSelectGroupBox: TGroupBox;
    ViewBankLabel: TLabel;
    ViewBankScrollBar: TScrollBar;
    SignalOptionsPanel: TPanel;
    SignalOptionsGroupBox: TGroupBox;
    AutoScaleCheckBox: TCheckBox;
    OverWriteCheckBox: TCheckBox;
    SynchroCheckBox: TCheckBox;
    DACEnableCheckBox: TCheckBox;
    AddrCntrTestCheckBox: TCheckBox;
    ExtStartCheckBox: TCheckBox;
    ClearDrawingAreaButton: TButton;
    Status1Label: TLabel;
    BankSizeLabel: TLabel;
    BankSizeComboBox: TComboBox;
    ActiveBankLabel: TLabel;
    SamplingStatusPanel: TPanel;
    SamplingStatusGroupBox: TGroupBox;
    SamplingStatusEdit: TEdit;
    SamplingInfoPanel: TPanel;
    SamplingInfoGroupBox: TGroupBox;
    CycFromProgStartLabel: TLabel;
    CycFromProgStartValue: TLabel;
    CycFromLastStartLabel: TLabel;
    CycFromLastStartValue: TLabel;
    TOutFromProgStartLabel: TLabel;
    TOutFromProgStartValue: TLabel;
    LocalMinMaxPanel: TPanel;
    LocalMinMaxGroupBox: TGroupBox;
    Ch1LocalMinEdit: TEdit;
    Ch1LocalMaxEdit: TEdit;
    Ch2LocalMinEdit: TEdit;
    Ch2LocalMaxEdit: TEdit;
    Ch1LocalMinLabel: TLabel;
    Ch1LocalMaxLabel: TLabel;
    Ch2LocalMinLabel: TLabel;
    Ch2LocalMaxLabel: TLabel;
    Ch1LocalMinMaxLabel: TLabel;
    Ch2LocalMinMaxLabel: TLabel;
    GlobMinMaxPanel: TPanel;
    GlobMinMaxGroupBox: TGroupBox;
    Ch1GlobMinEdit: TEdit;
    Ch1GlobMaxEdit: TEdit;
    Ch2GlobMinEdit: TEdit;
    Ch2GlobMaxEdit: TEdit;
    Ch1GlobMinLabel: TLabel;
    Ch1GlobMaxLabel: TLabel;
    Ch2GlobMinLabel: TLabel;
    Ch2GlobMaxLabel: TLabel;
    Ch1GlobMinMaxLabel: TLabel;
    Ch2GlobMinMaxLabel: TLabel;
    SynchroLevelPanel: TPanel;
    SynchroLevelRadioGroup: TRadioGroup;
    SynchroLevelTrackBar: TTrackBar;
    SynchroEdgePanel: TPanel;
    SynchroEdgeRadioGroup: TRadioGroup;
    SynchroRisingEdgeRadioButton: TRadioButton;
    SynchroFallingEdgeRadioButton: TRadioButton;
    SynchroOffset1Edit: TEdit;
    SynchroOffsetLabel: TLabel;
    StatisticPanel: TPanel;
    TypeDACSignalPanel: TPanel;
    TypeDACSignalGroupBox: TGroupBox;
    TypeDACSignalComboBox: TComboBox;
    DACBankSelectPanel: TPanel;
    DACBankSelectGroupBox: TGroupBox;
    DACBankSelectLabel: TLabel;
    DACViewBankScrollBar: TScrollBar;
    DACBankSizeLabel: TLabel;
    DACBankSizeComboBox: TComboBox;
    DACActiveBankLabel: TLabel;
    DACAutoScalePanel: TPanel;
    DACAutoScaleGroupBox: TGroupBox;
    DACAutoScaleCheckBox: TCheckBox;
    DACSignalPropPanel: TPanel;
    DACGenerateButton: TButton;
    DACSignalPropGroupBox: TGroupBox;
    DACVideoImpulsePanel: TPanel;
    VideoImpulseSignalBeginLabel: TLabel;
    VideoImpulseSignalBeginEdit: TEdit;
    VideoImpulseSignalEndLabel: TLabel;
    VideoImpulseSignalEndEdit: TEdit;
    VideoImpulseSignalOffsetLabel: TLabel;
    VideoImpulseSignalOffsetEdit: TEdit;
    VideoImpulseAmplifireLabel: TLabel;
    VideoImpulseAmplifireEdit: TEdit;
    DACVideoImpulseBurstPanel: TPanel;
    VideoImpulseBurstSignalBeginLabel: TLabel;
    VideoImpulseBurstSignalBeginEdit: TEdit;
    VideoImpulseBurstImpulseLengthLabel: TLabel;
    VideoImpulseBurstImpulseLengthEdit: TEdit;
    VideoImpulseBurstSignalOffsetLabel: TLabel;
    VideoImpulseBurstSignalOffsetEdit: TEdit;
    VideoImpulseBurstAmplifireLabel: TLabel;
    VideoImpulseBurstAmplifireEdit: TEdit;
    VideoImpulseBurstBetwenImpulsesLabel: TLabel;
    VideoImpulseBurstBetwenImpulsesEdit: TEdit;
    VideoImpulseBurstImpulsesNumberLabel: TLabel;
    VideoImpulseBurstImpulsesNumberEdit: TEdit;
    DACRadioImpulsePanel: TPanel;
    RadioImpulseSignalBeginLabel: TLabel;
    RadioImpulseSignalBeginEdit: TEdit;
    RadioImpulseSignalEndLabel: TLabel;
    RadioImpulseSignalEndEdit: TEdit;
    RadioImpulseSignalOffsetLabel: TLabel;
    RadioImpulseSignalOffsetEdit: TEdit;
    RadioImpulseAmplifireLabel: TLabel;
    RadioImpulseAmplifireEdit: TEdit;
    RadioImpulseFrequencyLabel: TLabel;
    RadioImpulseFrequencyEdit: TEdit;
    DACRadioImpulseBurstPanel: TPanel;
    RadioImpulseBurstSignalBeginLabel: TLabel;
    RadioImpulseBurstSignalBeginEdit: TEdit;
    RadioImpulseBurstImpulseLengthLabel: TLabel;
    RadioImpulseBurstImpulseLengthEdit: TEdit;
    RadioImpulseBurstBetwenImpulsesLabel: TLabel;
    RadioImpulseBurstBetwenImpulsesEdit: TEdit;
    RadioImpulseBurstImpulsesNumberLabel: TLabel;
    RadioImpulseBurstImpulsesNumberEdit: TEdit;
    RadioImpulseBurstFrequencyEdit: TEdit;
    RadioImpulseBurstFrequencyLabel: TLabel;
    RadioImpulseBurstSignalOffsetLabel: TLabel;
    RadioImpulseBurstSignalOffsetEdit: TEdit;
    RadioImpulseBurstSignalAmplifireLabel: TLabel;
    RadioImpulseBurstSignalAmplifireEdit: TEdit;
    DACLCHMImpulsePanel: TPanel;
    LCHMImpulseSignalBeginLabel: TLabel;
    LCHMImpulseSignalBeginEdit: TEdit;
    LCHMImpulseImpulseLengthLabel: TLabel;
    LCHMImpulseImpulseLengthEdit: TEdit;
    LCHMImpulseSignalOffsetLabel: TLabel;
    LCHMImpulseSignalOffsetEdit: TEdit;
    LCHMImpulseSignalAmplifireLabel: TLabel;
    LCHMImpulseSignalAmplifireEdit: TEdit;
    LCHMImpulseBeginFrequencyLabel: TLabel;
    LCHMImpulseBeginFrequencyEdit: TEdit;
    LCHMImpulseEndFrequencyLabel: TLabel;
    LCHMImpulseEndFrequencyEdit: TEdit;
    DACBarkerPanel: TPanel;
    BarkerSignalBeginLabel: TLabel;
    BarkerSignalBeginEdit: TEdit;
    BarkerFrequencyEdit: TEdit;
    BarkerFrequencyLabel: TLabel;
    BarkerSignalOffsetLabel: TLabel;
    BarkerSignalAmplifireEdit: TEdit;
    BarkerSignalAmplifireLabel: TLabel;
    BarkerSignalOffsetEdit: TEdit;
    BarkerPositionNumberLabel: TLabel;
    BarkerPositionNumberComboBox: TComboBox;
    BarkerPeriodByPositionLabel: TLabel;
    BarkerPeriodByPositionEdit: TEdit;
    StatisticLowPanel: TPanel;
    AverageBitsGroupBox: TGroupBox;
    AverageBitsChannel1Panel: TPanel;
    AverageBitsChannel1TitlePanel: TPanel;
    AverageBitsChannel1TitleLabel: TLabel;
    AveChn1Bit0Panel: TPanel;
    AveChn1Bit0Label: TLabel;
    AveChn1Bit0ValuePanel: TPanel;
    AveChn1Bit0ValueLabel: TLabel;
    AveChn1Bit1Panel: TPanel;
    AveChn1Bit1Label: TLabel;
    AveChn1Bit1ValuePanel: TPanel;
    AveChn1Bit1ValueLabel: TLabel;
    AveChn1Bit2Panel: TPanel;
    AveChn1Bit2Label: TLabel;
    AveChn1Bit6ValuePanel: TPanel;
    AveChn1Bit6ValueLabel: TLabel;
    AveChn1Bit3Panel: TPanel;
    AveChn1Bit3Label: TLabel;
    AveChn1Bit3ValuePanel: TPanel;
    AveChn1Bit3ValueLabel: TLabel;
    AveChn1Bit4Panel: TPanel;
    AveChn1Bit4Label: TLabel;
    AveChn1Bit4ValuePanel: TPanel;
    AveChn1Bit4ValueLabel: TLabel;
    AveChn1Bit5Panel: TPanel;
    AveChn1Bit5Label: TLabel;
    AveChn1Bit5ValuePanel: TPanel;
    AveChn1Bit5ValueLabel: TLabel;
    AveChn1Bit6Panel: TPanel;
    AveChn1Bit6Label: TLabel;
    AveChn1Bit2ValuePanel: TPanel;
    AveChn1Bit2ValueLabel: TLabel;
    AveChn1Bit7Panel: TPanel;
    AveChn1Bit7Label: TLabel;
    AveChn1Bit7ValuePanel: TPanel;
    AveChn1Bit7ValueLabel: TLabel;
    AveChn1Bit8Panel: TPanel;
    AveChn1Bit8Label: TLabel;
    AveChn1Bit8ValuePanel: TPanel;
    AveChn1Bit8ValueLabel: TLabel;
    AveChn1Bit9Panel: TPanel;
    AveChn1Bit9Label: TLabel;
    AveChn1Bit9ValuePanel: TPanel;
    AveChn1Bit9ValueLabel: TLabel;
    AveChn1Bit10Panel: TPanel;
    AveChn1Bit10Label: TLabel;
    AveChn1Bit10ValuePanel: TPanel;
    AveChn1Bit10ValueLabel: TLabel;
    AveChn1Bit11Panel: TPanel;
    AveChn1Bit11Label: TLabel;
    AveChn1Bit11ValuePanel: TPanel;
    AveChn1Bit11ValueLabel: TLabel;
    AveChn1Bit12Panel: TPanel;
    AveChn1Bit12Label: TLabel;
    AveChn1Bit12ValuePanel: TPanel;
    AveChn1Bit12ValueLabel: TLabel;
    AveChn1Bit13Panel: TPanel;
    AveChn1Bit13Label: TLabel;
    AveChn1Bit13ValuePanel: TPanel;
    AveChn1Bit13ValueLabel: TLabel;
    HistogrammsGroupBox: TGroupBox;
    Panel62: TPanel;
    Histogram1CaptionLabel: TLabel;
    Histogram1PaintBox: TPaintBox;
    HistogrammsPropGroupBox: TGroupBox;
    InputDataGroupBox: TGroupBox;
    InputDataSignalRadioButton: TRadioButton;
    InputDataNoiseRadioButton: TRadioButton;
    Histogram1GroupBox: TGroupBox;
    Histogram1RangeLabel: TLabel;
    Histogram1RangeValueLabel: TLabel;
    Histogram1BarsNumberLabel: TLabel;
    Histogram1BarsNumberEdit: TEdit;
    Histogram1MinValueLabel: TLabel;
    Histogram1MinValueEdit: TEdit;
    Histogram1MaxValueLabel: TLabel;
    Histogram1MaxValueEdit: TEdit;
    Histogram2GroupBox: TGroupBox;
    Histogram2BarsNumberLabel: TLabel;
    Histogram2BarsNumberEdit: TEdit;
    Histogram2MinValueLabel: TLabel;
    Histogram2MinValueEdit: TEdit;
    Histogram2MaxValueLabel: TLabel;
    Histogram2MaxValueEdit: TEdit;
    AverageBitsChannel2Panel: TPanel;
    AverageBitsChannel2TitlePanel: TPanel;
    AverageBitsChannel2TitleLabel: TLabel;
    AveChn2Bit0Panel: TPanel;
    AveChn2Bit0Label: TLabel;
    AveChn2Bit0ValuePanel: TPanel;
    AveChn2Bit0ValueLabel: TLabel;
    AveChn2Bit1Panel: TPanel;
    AveChn2Bit1Label: TLabel;
    AveChn2Bit1ValuePanel: TPanel;
    AveChn2Bit1ValueLabel: TLabel;
    AveChn2Bit2Panel: TPanel;
    AveChn2Bit2Label: TLabel;
    AveChn2Bit2ValuePanel: TPanel;
    AveChn2Bit2ValueLabel: TLabel;
    AveChn2Bit3Panel: TPanel;
    AveChn2Bit3Label: TLabel;
    AveChn2Bit3ValuePanel: TPanel;
    AveChn2Bit3ValueLabel: TLabel;
    AveChn2Bit4Panel: TPanel;
    AveChn2Bit4Label: TLabel;
    AveChn2Bit4ValuePanel: TPanel;
    AveChn2Bit4ValueLabel: TLabel;
    AveChn2Bit5Panel: TPanel;
    AveChn2Bit5Label: TLabel;
    AveChn2Bit5ValuePanel: TPanel;
    AveChn2Bit5ValueLabel: TLabel;
    AveChn2Bit6Panel: TPanel;
    AveChn2Bit6Label: TLabel;
    AveChn2Bit6ValuePanel: TPanel;
    AveChn2Bit6ValueLabel: TLabel;
    AveChn2Bit7Panel: TPanel;
    AveChn2Bit7Label: TLabel;
    AveChn2Bit7ValuePanel: TPanel;
    AveChn2Bit7ValueLabel: TLabel;
    AveChn2Bit8Panel: TPanel;
    AveChn2Bit8Label: TLabel;
    AveChn2Bit8ValuePanel: TPanel;
    AveChn2Bit8ValueLabel: TLabel;
    AveChn2Bit9Panel: TPanel;
    AveChn2Bit9Label: TLabel;
    AveChn2Bit9ValuePanel: TPanel;
    AveChn2Bit9ValueLabel: TLabel;
    AveChn2Bit10Panel: TPanel;
    AveChn2Bit10Label: TLabel;
    AveChn2Bit10ValuePanel: TPanel;
    AveChn2Bit10ValueLabel: TLabel;
    AveChn2Bit11Panel: TPanel;
    AveChn2Bit11Label: TLabel;
    AveChn2Bit11ValuePanel: TPanel;
    AveChn2Bit11ValueLabel: TLabel;
    AveChn2Bit12Panel: TPanel;
    AveChn2Bit12Label: TLabel;
    AveChn2Bit12ValuePanel: TPanel;
    AveChn2Bit12ValueLabel: TLabel;
    AveChn2Bit13Panel: TPanel;
    AveChn2Bit13Label: TLabel;
    AveChn2Bit13ValuePanel: TPanel;
    AveChn2Bit13ValueLabel: TLabel;
    StatisticGroupBox: TGroupBox;
    StatisticChannel1GroupBox: TGroupBox;
    StatisticChannel1ZeroLevelLabel: TLabel;
    StatisticChannel1ZeroLevelEdit: TEdit;
    StatisticChannel1NoiseLevelLabel: TLabel;
    StatisticChannel1NoiseLevelEdit: TEdit;
    StatisticChannel2GroupBox: TGroupBox;
    StatisticChannel2ZeroLevelLabel: TLabel;
    StatisticChannel2ZeroLevelEdit: TEdit;
    StatisticChannel2NoiseLevelLabel: TLabel;
    StatisticChannel2NoiseLevelEdit: TEdit;
    Panel63: TPanel;
    Histogram2PaintBox: TPaintBox;
    Histogram2CaptionLabel: TLabel;
    Histogram2RangeLabel: TLabel;
    Histogram2RangeValueLabel: TLabel;
    CalculateHistogramCheckBox: TCheckBox;
    ClearHistogrammsButton: TButton;
    CalculateStatisticCheckBox: TCheckBox;
    FileSave: TMenuItem;
    FileClose: TMenuItem;
    SaveDialog: TSaveDialog;
    Device0Devices: TMenuItem;
    Device1Devices: TMenuItem;
    Device2Devices: TMenuItem;
    Device3Devices: TMenuItem;
    FilePrint: TMenuItem;
    Separator2: TMenuItem;
    BankOffsetRightButton: TButton;
    BankOffsetLeftButton: TButton;
    BankOffsetLabel: TLabel;
    BankOffsetRight10Button: TButton;
    BankOffsetLeft10Button: TButton;
    ClearBankOffsetButton: TButton;
    BankOffsetTitleLabel: TLabel;
    Separator3: TMenuItem;
    SignalDrawDotsCheckBox: TCheckBox;
    SignalScaleLowButton: TButton;
    SignalScaleLow1Button: TButton;
    SignalScaleHighButton: TButton;
    SignalScaleHigh1Button: TButton;
    SynchroOffsetChn1Label: TLabel;
    SynchroOffsetChn2Label: TLabel;
    SynchroOffset2Edit: TEdit;
    InputDataInActiveBankCheckBox: TCheckBox;
    CalculateCountLabel: TLabel;
    CalculateCountValueLabel: TLabel;
    OpenDialog: TOpenDialog;
    Device0Tab: TTabSheet;
    Device1Tab: TTabSheet;
    Device2Tab: TTabSheet;
    Device3Tab: TTabSheet;
    DACPropertiesPanel: TPanel;
    DACPropertiesGroupBox: TGroupBox;
    FrequencyDividerEdit: TEdit;
    FrequencyDividerButton: TButton;
    FrequencyDividerLabel: TLabel;
    ExternalPuskEdgeCheckBox: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    TabSheet1: TTabSheet;
    DMATransactionCheckBox: TCheckBox;
    DAC1DefaultValueEdit: TEdit;
    DAC2DefaultValueEdit: TEdit;
    DAC1DefaultValueLabel: TLabel;
    DAC2DefaultValueLabel: TLabel;
    SetDACDefaultValueButton: TButton;
    HistBuffCheckBox: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ADC1normalRadioButton: TRadioButton;
    ADC1ADCRadioButton: TRadioButton;
    ADC1FIFORadioButton: TRadioButton;
    ADC2normalRadioButton: TRadioButton;
    ADC2ADCRadioButton: TRadioButton;
    RadioButton6: TRadioButton;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    ADC1normalPatternRadioButton: TRadioButton;
    ADC1All0PatternRadioButton: TRadioButton;
    ADC1All1PatternRadioButton: TRadioButton;
    ADC1TogglesRadioButton: TRadioButton;
    ADC2normalPatternRadioButton: TRadioButton;
    ADC2All0PatternRadioButton: TRadioButton;
    ADC2All1PatternRadioButton: TRadioButton;
    ADC2TogglesRadioButton: TRadioButton;
    DigitControl: TTabSheet;
    DIN0CheckBox: TCheckBox;
    DIN1CheckBox: TCheckBox;
    DIN2CheckBox: TCheckBox;
    DIN3CheckBox: TCheckBox;
    DOUT0CheckBox: TCheckBox;
    DOUT1CheckBox: TCheckBox;
    DOUT2CheckBox: TCheckBox;
    DOUT3CheckBox: TCheckBox;
    XDSP_NotProcessFlag_TO_DOUT0CheckBox: TCheckBox;
    XDSP_ProcessFlag_TO_DOUT1CheckBox: TCheckBox;
    XDSP_ExtPuskEnable_TO_DOUT2CheckBox: TCheckBox;
    XDSP_NotExtPuskEnable_TO_DOUT3CheckBox: TCheckBox;
    DIN4CheckBox: TCheckBox;
    DIN5CheckBox: TCheckBox;
    DOUT4CheckBox: TCheckBox;
    DOUT5CheckBox: TCheckBox;
    XDSP_PCI_enable_TO_DOUT4CheckBox: TCheckBox;
    XDSP_NotPCI_enable_TO_DOUT5CheckBox: TCheckBox;
    EnableDigExtStartCheckBox: TCheckBox;
    CalcGlobalMinMax: TCheckBox;
    AverageCheckBox: TCheckBox;
    AverageNumberEdit: TEdit;
    Label1: TLabel;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure RefreshTimerTimer(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure DevicePageControlChange(Sender: TObject);
    procedure BankSizeComboBoxChange(Sender: TObject);
    procedure ViewBankScrollBarChange(Sender: TObject);
    procedure ClearDrawingAreaButtonClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SignalsPageControlChange(Sender: TObject);
    procedure DACEnableCheckBoxClick(Sender: TObject);
    procedure AddrCntrTestCheckBoxClick(Sender: TObject);
    procedure ExtStartCheckBoxClick(Sender: TObject);
    procedure DACBankSizeComboBoxChange(Sender: TObject);
    procedure DACViewBankScrollBarChange(Sender: TObject);
    procedure TypeDACSignalComboBoxChange(Sender: TObject);
    procedure DACGenerateButtonClick(Sender: TObject);
    procedure DACAutoScaleCheckBoxClick(Sender: TObject);
    procedure Channel1RadioButtonClick(Sender: TObject);
    procedure Channel2RadioButtonClick(Sender: TObject);
    procedure Channel12RadioButtonClick(Sender: TObject);
    procedure ChannelSubRadioButtonClick(Sender: TObject);
    procedure CalculateHistogramCheckBoxClick(Sender: TObject);
    procedure ClearHistogrammsButtonClick(Sender: TObject);
    procedure Histogram1PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Histogram2PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure SignalPaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure AutoScaleCheckBoxClick(Sender: TObject);
    procedure SignalPaintBoxMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SignalPaintBoxMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FileSaveClick(Sender: TObject);
    procedure FileLoadClick(Sender: TObject);
    procedure FileCloseClick(Sender: TObject);
    procedure BankOffsetRightButtonClick(Sender: TObject);
    procedure BankOffsetLeftButtonClick(Sender: TObject);
    procedure BankOffsetRight10ButtonClick(Sender: TObject);
    procedure BankOffsetLeft10ButtonClick(Sender: TObject);
    procedure ClearBankOffsetButtonClick(Sender: TObject);
    procedure SignalScaleLowButtonClick(Sender: TObject);
    procedure SignalScaleLow1ButtonClick(Sender: TObject);
    procedure SignalScaleHighButtonClick(Sender: TObject);
    procedure SignalScaleHigh1ButtonClick(Sender: TObject);
    procedure FrequencyDividerButtonClick(Sender: TObject);
    procedure ExternalPuskEdgeCheckBoxClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SetDACDefaultValueButtonClick(Sender: TObject);
    procedure HistBuffCheckBoxClick(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure ADC1normalRadioButtonClick(Sender: TObject);
    procedure ADC1ADCRadioButtonClick(Sender: TObject);
    procedure ADC1FIFORadioButtonClick(Sender: TObject);
    procedure ADC2normalRadioButtonClick(Sender: TObject);
    procedure ADC2ADCRadioButtonClick(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure ADC1normalPatternRadioButtonClick(Sender: TObject);
    procedure ADC1All0PatternRadioButtonClick(Sender: TObject);
    procedure ADC1All1PatternRadioButtonClick(Sender: TObject);
    procedure ADC1TogglesRadioButtonClick(Sender: TObject);
    procedure ADC2normalPatternRadioButtonClick(Sender: TObject);
    procedure ADC2All0PatternRadioButtonClick(Sender: TObject);
    procedure ADC2All1PatternRadioButtonClick(Sender: TObject);
    procedure ADC2TogglesRadioButtonClick(Sender: TObject);
    procedure EnableDigExtStartCheckBoxClick(Sender: TObject);
    procedure Device1DevicesClick(Sender: TObject);
    procedure Device0DevicesClick(Sender: TObject);
    procedure Device2DevicesClick(Sender: TObject);
    procedure Device3DevicesClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);

  private
  public
    // Update current drawing area to virtual screen
    Procedure UpdateScreen;
    Procedure UpdateSignalScreen;
    Procedure UpdateDACScreen;
    Procedure UpdateStatisticScreen;
    // Flip virtual screen to drawing PaintBox
    Procedure FlipToScr;
    // Modelling DMA Buffer
    Procedure ADC_ModelData;
    // Read data from DMA Buffer to Channel Arrays
    Procedure ADC_ReadData;
    Procedure ADC_NormalizeData;
    // Draw line to Canvas
    Procedure PaintLine(Canvas:TCanvas;x0,y0,x1,y1:integer);
    Procedure PaintDot(Canvas:TCanvas;x0,y0:integer);
    // Draw signal array to virtual screen
    Procedure PaintRealArray(A:TRealA;_Color:TColor;draw_rect:TRect);
    Procedure DACPaintRealArray(A:TRealA;_Color:TColor;draw_rect:TRect);

    Procedure PaintDINArray(_Color:TColor;draw_rect:TRect);
    // Procedures for Diagnostic
    Procedure DiagDeviceNotReady;
    Procedure DiagDeviceReady;
    // Procedures for DAC Signal Generation
    Procedure UpdateDACPropPanel;
    // Procedures for generating misc DAC Signals
    Procedure GenerateVideoImpulse;
    Procedure GenerateVideoImpulseBurst;
    Procedure GenerateRadioImpulse;
    Procedure GenerateRadioImpulseBurst;
    Procedure GenerateLCHMImpulse;
    Procedure GenerateBarkerCode;
    // Procedure for generating statistic information
    Procedure CalculateStatistic;
    // Procedure for histogramms;
    procedure ClearHistograms;
    procedure DrawHistograms;
    procedure CalcHistograms;
    Procedure FindLocalMinMax(A:TRealA; ActiveBank_:Integer; BankLen_:Integer; synchro:Boolean);
    Procedure FindLocalMinMax_(A:TA; ActiveBank_:Integer; BankLen_:Integer; synchro:Boolean);
    Procedure FindGlobalMinMax;

    procedure WriteToDAC(data_write : Word);
    procedure WriteToADC(data_write : Word; ADC1_enable : boolean; ADC2_enable : boolean);
    procedure WriteDigOutData;
    procedure ReadDigInData;
  end;

// Thread for reading data and update screen
type
  TSignalThread = class(TThread)
  private
  protected
    procedure Execute; override;
  end;

// Record for saving XDspDevice data for each found device
Type TXdspDevice=Record
  DeviceHandle:THandle;
  InterruptHandle:THandle;
  DmaBuffer1:PDmaMemoryBuffer;
  DmaBuffer2:PDmaMemoryBuffer;
  DmaBuffer3:PDmaMemoryBuffer;
  DmaBuffer4:PDmaMemoryBuffer;
  DmaBufferPhysAddr1:PDWord;
  DmaBufferPhysAddr2:PDWord;
  DmaBufferPhysAddr3:PDWord;
  DmaBufferPhysAddr4:PDWord;
End;

var
  FREQDISCRETE_HZ:Integer=100000000;

var
  MainForm: TMainForm;                    // Main form object
  SignalThread:TSignalThread;             // Thread object for screen update
  SignalVScr:TBitmap;                     // Virtual screen for drawing
  refresh_screen:Boolean;                 // Refresh screen by timer when need

  BankLen:Integer=512;                    // Current bank length
  ActiveBank:Integer=0;                   // Active bank
  DACBankLen:Integer=512;                 // Current DAC bank length
  DACActiveBank:Integer=0;                // Active DAC bank
  CorrBankLen:Integer=512;                // Current correlation bank length
  CorrActiveBank:Integer=0;               // Active correlation bank
  FFTBankLen:Integer=128;                 // Current correlation bank length
  FFTActiveBank:Integer=0;                // Active correlation bank

  XDspDevices:Array[0..4] Of TXDSPDevice; // XDdspDevices, 0 - Model
  active_device:Integer;                  // Active working device

  IntrWaitTimeOut:DWord=1000;             // Timeout for interrupt waiting
  signal_bitrate:Integer=14;              // ADC bit rate
  signal_zerolevel:Integer=8192;          // ADC signal zero level
  signal_range:Integer=16384;              // ADC signal range
  dac_bitrate:Integer=14;                  // DAC bit rate
  dac_range:Integer=16384;                // DAC signal range
  dac_zerolevel:Integer=8192;              // DAC zero level
  dac_maxamp:Integer=8191;                 // DAC maximal amplitude
  dac_minamp:Integer=-8192;                   // DAC minimal amplitude
  DAC1DefaultValue:Integer=8192;              // DAC1 value in static mode
  DAC2DefaultValue:Integer=8192;              // DAC2 value in static mode

  F_Stop:Boolean;                         // Stop thread flag

  // Array for channels data for current device
  RealDataArray_Chn0   :TRealArray;
  RealDataArray_Chn1   :TRealArray;

  RealDataArray_ChnSub :TRealArray;

  DACArray             : TRealArray;
  PatternArray         : TRealArray;

  CorrArray            : TArray;
  SigArr : Array[0..ADCBufLen] of Integer;
  PatArr : Array[0..ADCBufLen] of Integer;

  // General signal max and min values finding in ADC_ReadData
  RealgMin0,RealgMax0,RealgMin1,RealgMax1:Real;

  // Local min,max finding in PaintArray
  RealMin,RealMax:Real;
  ReallMin0,ReallMax0,ReallMin1,ReallMax1:Real;
  GlobalMin0,GlobalMax0,GlobalMin1,GlobalMax1:Real;
  DACReallMin,DACReallMax:Real;
  CorrReallMin,CorrReallMax:Real;
  FFTReallMin0,FFTReallMax0,FFTReallMin1,FFTReallMax1:Real;

  // Diagnostic values
  CycleFromLStartCount:Integer;
  CycleFromPStartCount:Integer=0;
  TimeoutFromLStartCount:Integer;
  TimeoutFromPStartCount:Integer=0;

  // Synchronize level and constants
  SynchroLevel:integer;

  //ADC DAC
  ADC_REG,DAC_REG : Word;

  dev_count : integer = 0;
  AverageCount : DWord;
  AverageNumber : DWord;  
  
Const
  SynchroGister     = 1;
 _PaintDly         = 0{30};

Var
  AveCount:Integer;

  Chn1,Chn2 : Array[0..13] Of Integer;
  Chn1ZeroLevel,Chn2ZeroLevel,Chn1Shum,Chn2Shum : Double;

  Hist1Box:TBitmap;
  Hist2Box:TBitmap;

  Hist1BarsNum:Integer;
  Hist2BarsNum:Integer;
  Hist1ValueMin,Hist1ValueMax:Double;
  Hist2ValueMin,Hist2ValueMax:Double;
  HistMassCount:Integer;
  Hist1BarsValues:Array[0..4095] Of Integer;
  Hist2BarsValues:Array[0..4095] Of Integer;
  Hist1BarStep:Integer;
  Hist1BarStepReal:Double;
  Hist2BarStep:Integer;
  Hist2BarStepReal:Double;

  RealDataFFT_re:TRealArray;
  RealDataFFT_im:TRealArray;
  RealDataFFT_re_:TRealArray;
  RealDataFFT_im_:TRealArray;
  FFTPointsNumber:Integer;
  FFTPointsOffset:Integer;

  BankOffset:Integer=0;
 _offset:Integer=0;
 _offset1:Integer=0;
 _offset2:Integer=0;
 _stepx:Real=1;

  stepx,stepy: Integer;
  stepx_: Double = 1;
  stepy_: Double = 1;
  sx1,sy1,sx2,sy2: Integer;

  Zoom_X1,Zoom_X2:Integer;
  Zoom_BeginDrag:Boolean;
  Zoom_Allow:Boolean;

  Registry:TRegistry;

  cfg_file:TextFile;

  SignalScaleYCoefficient:Double=1;
  FFTScaleYCoefficient:Double=1;

  FFTAxisMax:Integer=40;

  DataArray_DIN : Array[0..ADCBufLen,1..5] Of Byte;

implementation
{$R *.xfm}

Procedure TMainForm.FormCreate(Sender: TObject);
Var
  i:Integer;
  hnd:THandle;
  status : DWORD;
Begin
  MainForm.BorderIcons:=[bisystemmenu,biminimize];
  MainForm.Caption:='WIN_DO Oscilloscope v.'+FormatFloat('0.00',VERSION);

  Registry:=TRegistry.Create;

  If Not Registry.OpenKey('XDspOscilloscope',False) Then Begin
    If Not Registry.CreateKey('XDspOscilloscope') Then ShowMessage('Error access registry');
    Registry.OpenKey('XDspOscilloscope',False);
    Registry.WriteBool('XdspDevice0Busy',False);
    Registry.WriteBool('XdspDevice1Busy',False);
    Registry.WriteBool('XdspDevice2Busy',False);
    Registry.WriteBool('XdspDevice3Busy',False);
  End Else Begin
    Registry.OpenKey('XDspOscilloscope',False);
    Registry.WriteBool('XdspDevice0Busy',False);
    Registry.WriteBool('XdspDevice1Busy',False);
    Registry.WriteBool('XdspDevice2Busy',False);
    Registry.WriteBool('XdspDevice3Busy',False);
  End;

  For i:=1 To 4 Do
  Begin
    If Not Registry.ReadBool('XdspDevice'+IntToStr(i-1)+'Busy') Then Begin
    hnd:=XdspOpenDevice((i-1),@XDspDevices[i].InterruptHandle,@XDspDevices[i].DmaBuffer1,@XDspDevices[i].DmaBuffer2,@XDspDevices[i].DmaBuffer3,@XDspDevices[i].DmaBuffer4,
                        @XDspDevices[i].DmaBufferPhysAddr1,@XDspDevices[i].DmaBufferPhysAddr2,@XDspDevices[i].DmaBufferPhysAddr3,@XDspDevices[i].DmaBufferPhysAddr4);
    If hnd=XDSP_INVALID_DEVICE_HANDLE Then Begin
      //Application.MessageBox('Not found device '+IntToStr(i-1),'Attention');
      Case i Of
        1: Begin Device0Devices.Checked:=false; Device0Tab.TabVisible:=False; Device0Devices.Enabled:=false; End;
        2: Begin Device1Devices.Checked:=False; Device1Tab.TabVisible:=False; Device1Devices.Enabled:=false; End;
        3: Begin Device2Devices.Checked:=False; Device2Tab.TabVisible:=False; Device2Devices.Enabled:=false; End;
        4: Begin Device3Devices.Checked:=False; Device3Tab.TabVisible:=False; Device3Devices.Enabled:=false; End;
      End;
    End
    Else
    Begin
      dev_count := dev_count + 1;
      Registry.WriteBool('XdspDevice'+IntToStr(i-1)+'Busy',True);
      Case i Of
        1: Begin Device0Tab.TabVisible:=True; Device0Devices.Enabled:=true; End;
        2: Begin Device1Tab.TabVisible:=True; Device1Devices.Enabled:=true; End;
        3: Begin Device2Tab.TabVisible:=True; Device2Devices.Enabled:=true; End;
        4: Begin Device3Tab.TabVisible:=True; Device3Devices.Enabled:=true; End;
      End;
      if Device0Tab.TabVisible = true then
      begin
           Device0Devices.Checked:=True; Device1Devices.Checked:=false; Device2Devices.Checked:=false; Device3Devices.Checked:=false;
      end
      else if Device1Tab.TabVisible = true then
      begin
           Device0Devices.Checked:=false; Device1Devices.Checked:=true; Device2Devices.Checked:=false; Device3Devices.Checked:=false;
      end
      else if Device2Tab.TabVisible = true then
      begin
           Device0Devices.Checked:=false; Device1Devices.Checked:=false; Device2Devices.Checked:=true; Device3Devices.Checked:=false;
      end
      else if Device3Tab.TabVisible = true then
      begin
           Device0Devices.Checked:=false; Device1Devices.Checked:=false; Device2Devices.Checked:=false; Device3Devices.Checked:=true;
      end;
      XDspDevices[i].DeviceHandle:=hnd;
      XdspResetAll(hnd);
      XdspSetProcessLength(hnd,XDSP_BOARD_MEMORY);
      XdspSetSampleFrequencyDivider(hnd,1);
      XDSPSetDAC1Default(XDspDevices[i].DeviceHandle,DAC1DefaultValue);
      XDSPSetDAC2Default(XDspDevices[i].DeviceHandle,DAC2DefaultValue);
      XdspResetAll(hnd);

      active_device := i;
      // config ADC
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0011,true,false);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0100,true,false);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0000,true,false);
      ADC_REG := 0;
      //config ADC
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0000,false,true);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$2000,false,true);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0000,false,true);
      DAC_REG := 0;
      // DAC sintesize disable
      XdspDACDisable(XDspDevices[i].DeviceHandle);
    End;
    End;
  End;

  if dev_count > 0 then begin
     ModelTab.TabVisible:=false;
     DevicesMenu.Enabled := true;
     active_device:=1;
  end else begin
     ModelTab.TabVisible:=true;
     DevicesMenu.Enabled := false;
     active_device:=0;
  end;

  SignalThread:=TSignalThread.Create(True);

  SignalVScr:=TBitmap.Create;
  SignalVScr.Width:=SignalPaintBox.Width;
  SignalVScr.Height:=SignalPaintBox.Height;

  SignalVScr.Canvas.SetClipRect(Rect(10,10,SignalVscr.Width-20,SignalVScr.Height-20));

  Hist1Box:=TBitmap.Create;
  Hist1Box.Width:=Histogram1PaintBox.Width;
  Hist1Box.Height:=Histogram1PaintBox.Height;
  Hist2Box:=TBitmap.Create;
  Hist2Box.Width:=Histogram2PaintBox.Width;
  Hist2Box.Height:=Histogram2PaintBox.Height;

  ViewBankScrollBar.Max:=(XDSP_BOARD_MEMORY div BankLen)-1;
  DACViewBankScrollBar.Max:=(XDSP_BOARD_MEMORY div DACBankLen)-1;

  UpdateDACPropPanel;

  ClearHistograms;
  Hist1BarsNum:=StrToInt(Histogram1BarsNumberEdit.Text);
  Hist2BarsNum:=StrToInt(Histogram2BarsNumberEdit.Text);
  Hist1ValueMin:=StrToInt(Histogram1MinValueEdit.Text);
  Hist1ValueMax:=StrToInt(Histogram1MaxValueEdit.Text);
  Hist2ValueMin:=StrToInt(Histogram2MinValueEdit.Text);
  Hist2ValueMax:=StrToInt(Histogram2MaxValueEdit.Text);

  Hist1BarStep:=Trunc((Hist1ValueMax-Hist1ValueMin)/Hist1BarsNum);
  Hist1BarStepReal:=(Hist1ValueMax-Hist1ValueMin)/Hist1BarsNum;
  Hist2BarStep:=Trunc((Hist2ValueMax-Hist2ValueMin)/Hist2BarsNum);
  Hist2BarStepReal:=(Hist2ValueMax-Hist2ValueMin)/Hist2BarsNum;

  Zoom_Allow:=True;

End;

Procedure TMainForm.DiagDeviceNotReady;
Begin
  Inc(TimeoutFromPStartCount);
  Inc(TimeoutFromLStartCount);
  MainForm.TOutFromProgStartValue.Caption:=IntToStr(TimeoutFromPStartCount);
  MainForm.SamplingStatusEdit.Text:=' ';
  MainForm.StartButton.Enabled:=true;
  MainForm.StopButton.Enabled:=false;
End;

Procedure TMainForm.DiagDeviceReady;
Begin
  Inc(CycleFromLStartCount);
  Inc(CycleFromPStartCount);
  MainForm.CycFromLastStartValue.Caption:=Inttostr(CycleFromLStartCount);
  MainForm.CycFromProgStartValue.Caption:=IntToStr(CycleFromPStartCount);
  MainForm.SamplingStatusEdit.Text:=' ';
End;

Procedure TSignalThread.Execute;
Var
  i,status:Integer;
  port_data:DWORD;
  DMATrCB:DWORD;
Begin
  While(Not Terminated) Do
  Begin
      // Normal (not average) signal

      If active_device>0 Then
      Begin
        MainForm.WriteDigOutData;
        MainForm.ReadDigInData;
        // Working with active_device XDspDevice
        XdspResetAll(XDspDevices[active_device].DeviceHandle);

        if MainForm.DMATransactionCheckBox.Checked then
        begin
          DMATrCB := 1;
        end
        else
          DMATrCB := 0;

        status := XDspStartRead(XDspDevices[active_device].DeviceHandle,3000,DMATrCB);


        If status=XDSP_STATUS_SUCCESS Then
        Begin
          // Read device data
          MainForm.ADC_ReadData;
          if MainForm.AverageCheckBox.Checked then
            begin
              AverageCount :=AverageCount+1;
              if AverageCount = AverageNumber then
                begin
                 AverageCount:=0;
                 Synchronize(MainForm.ADC_NormalizeData);                 
                 // Update screen
                 Synchronize(MainForm.UpdateScreen);
                 Synchronize(MainForm.FlipToScr);
                end
            end
          else
            begin
             // Update screen
             Synchronize(MainForm.UpdateScreen);
             Synchronize(MainForm.FlipToScr);
            end;
          // DeviceReady diagnostic data
          Synchronize(MainForm.DiagDeviceReady);
          if (F_Stop and ((AverageCount=0) or (not MainForm.AverageCheckBox.Checked)))then
          begin
            MainForm.StartButton.Enabled:=True;
            MainForm.StopButton.Enabled:=False;
            Suspend;
          end;
        End Else
        Begin
          // Device NOT Ready diagnostic data
          Synchronize(MainForm.DiagDeviceNotReady);
          Suspend;
        End;
        // END Working with active_device XDspDevice
      End Else
      Begin
        // Working with model
        // Model device data
        MainForm.ADC_ModelData;
        // Update screen
        Synchronize(MainForm.UpdateScreen);
        Synchronize(MainForm.FlipToScr);
        // DeviceReady diagnostic data
        Synchronize(MainForm.DiagDeviceReady);
        if F_Stop then
        begin
          MainForm.StartButton.Enabled:=True;
          MainForm.StopButton.Enabled:=False;
          Suspend;
        end;
        // END Working with model
      End;
  End;
End;

Procedure TMainForm.RefreshTimerTimer(Sender: TObject);
Begin
  If refresh_screen Then Begin
    refresh_screen:=False;
    UpdateScreen;
    FlipToScr;
  End;
End;

Procedure DrawAxis(SignalVScr:TBitmap; xaxislabel_from,xaxislabel_to:Double; yaxislabel_from,yaxislabel_to:Double; autoscale:Boolean);
Var
  i:Integer;
  x1,y1,x2,y2:Integer;
  axis_label:String;
  axis_width:Integer;
Begin
  SignalVScr.Canvas.Pen.Color:=RGB(221,134,38);
  SignalVscr.Canvas.Pen.Style:=psSolid;
  SignalVScr.Canvas.MoveTo(30,4);
  SignalVScr.Canvas.LineTo(30,SignalVScr.Height-20);
  SignalVScr.Canvas.MoveTo(30,SignalVScr.Height-20);
  SignalVScr.Canvas.LineTo(SignalVScr.Width-6,SignalVScr.Height-20);

  SignalVscr.Canvas.Pen.Color:=clGray;
  SignalVscr.Canvas.Pen.Style:=psDot;

  SignalVScr.Canvas.Font.Color:=clYellow;

  stepy:=(SignalVScr.Height-4-20-6) div 8;
  x1:=30; x2:=SignalVScr.Width-7;

  SignalVScr.Canvas.Brush.Color:=clBlack;
  SignalVScr.Canvas.FillRect(Rect(0,0,29,SignalVScr.Height));
  SignalVscr.Canvas.FillRect(Rect(29,SignalVscr.Height-18,SignalVscr.Width,SignalVscr.Height));
  For i:=0 To 8 Do Begin
    y1:=SignalVScr.Height-20-3-i*stepy;
    y2:=y1;
    SignalVScr.Canvas.MoveTo(x1,y1);
    SignalVScr.Canvas.LineTo(x2,y2);
    If Not autoscale Then Begin
    {If i=3 Then axis_label:='0' Else }axis_label:=FormatFloat('0.#',yaxislabel_to-((yaxislabel_to-yaxislabel_from)/8)*(8-i-1));
    axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
    y1:=4+(8-i-1)*stepy;
    If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-3,axis_label)
    Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-3,axis_label);
    End Else Begin
    If i=7 Then Begin
    axis_label:=FormatFloat('0.#',yaxislabel_to);
    axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
    y1:=4+(8-i-1)*stepy;
    If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-3,axis_label)
    Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-3,axis_label);
    End;
    End;
  End;
  axis_label:=FormatFloat('0',yaxislabel_from);
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  y1:=SignalVScr.Height-20;
  If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-12,axis_label)
  Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-12,axis_label);

  stepx:=(SignalVScr.Width-4-30-6) div 8;
  y1:=4; y2:=SignalVScr.Height-20;

  For i:=0 To 8 Do Begin
    x1:=33+i*stepx;
    x2:=x1;
    SignalVScr.Canvas.MoveTo(x1,y1);
    SignalVScr.Canvas.LineTo(x2,y2);
    //If xaxislabel_to-xaxislabel_from>8 Then Begin
    //axis_label:=IntToStr(xaxislabel_from+Round( (i-1)*(xaxislabel_to-xaxislabel_from)/8 ));
    //End Else Begin
    axis_label:=FormatFloat('0.#', xaxislabel_from+(i-1)*(xaxislabel_to-xaxislabel_from)/8 );
    //End;
    axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
    x1:=33+(i-1)*stepx;
    SignalVScr.Canvas.TextOut(x1-(axis_width div 2),y2+4,axis_label);
    //SignalVScr.Canvas.MoveTo(x1-(axis_width div 2),y2-2);
    //SignalVScr.Canvas.LineTo(x1-(axis_width div 2),y2+2);
  End;
  i:=9;
  axis_label:=FormatFloat('0.#',xaxislabel_to);
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  x1:=30+(i-1)*stepx;
  SignalVScr.Canvas.TextOut(x1-axis_width+5,y2+4,axis_label);

  SignalVScr.Canvas.Pen.Color:=RGB(221,134,38);
  SignalVscr.Canvas.Pen.Style:=psSolid;

  sx1:=33; sx2:=33+8*stepx;
  sy1:=7;  sy2:=7+8*stepy;
End;

Procedure DrawAxis2(SignalVScr:TBitmap; xaxislabel_from1,xaxislabel_to1,xaxislabel_from2,xaxislabel_to2:Double; yaxis1label_from,yaxis1label_to,yaxis2label_from,yaxis2label_to:Double; autoscale:Boolean);
Var
  i:Integer;
  x1,y1,x2,y2:Integer;
  axis_label:String;
  axis_width:Integer;
Begin
  SignalVScr.Canvas.Pen.Color:=RGB(221,134,38);
  SignalVscr.Canvas.Pen.Style:=psSolid;
  SignalVScr.Canvas.MoveTo(30,4);
  SignalVScr.Canvas.LineTo(30,SignalVScr.Height-20);
  SignalVScr.Canvas.MoveTo(30,SignalVScr.Height-20);
  SignalVScr.Canvas.LineTo(SignalVScr.Width-6,SignalVScr.Height-20);

  stepy:=(SignalVScr.Height-4-20-6) div 8;
  x1:=30; x2:=SignalVScr.Width-7;

  SignalVscr.Canvas.Pen.Color:=clGray;
  SignalVscr.Canvas.Pen.Style:=psDot;

  SignalVScr.Canvas.Font.Color:=clYellow;

  SignalVScr.Canvas.Brush.Color:=clBlack;
  SignalVScr.Canvas.FillRect(Rect(0,0,29,SignalVScr.Height));
  SignalVscr.Canvas.FillRect(Rect(29,SignalVscr.Height-18,SignalVscr.Width,SignalVscr.Height));
  For i:=0 To 7 Do Begin
    y1:=SignalVScr.Height-20-3-i*stepy;
    y2:=y1;
    SignalVScr.Canvas.MoveTo(x1,y1);
    SignalVScr.Canvas.LineTo(x2,y2);
  End;
  If Not autoscale Then Begin
  axis_label:=FormatFloat('0.#',yaxis1label_to-((yaxis1label_to-yaxis1label_from)/2));
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  y1:=4+(8-1-1)*stepy;
  If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-3,axis_label)
  Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-3,axis_label);
  axis_label:=FormatFloat('0.#',yaxis2label_to-((yaxis2label_to-yaxis2label_from)/2));
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  y1:=4+(8-5-1)*stepy;
  If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-3,axis_label)
  Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-3,axis_label);
  End;
  axis_label:=FormatFloat('0.#',yaxis1label_to);
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  y1:=4+(8-3-1)*stepy;
  If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-3+10,axis_label)
  Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-3+10,axis_label);
  axis_label:=FormatFloat('0.#',yaxis2label_from);
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-3-7,axis_label)
  Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-3-7,axis_label);
  axis_label:=FormatFloat('0.#',yaxis2label_to);
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  y1:=4+(8-7-1)*stepy;
  If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-3,axis_label)
  Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-3,axis_label);
  axis_label:=FormatFloat('0.#',yaxis1label_from);
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  y1:=SignalVScr.Height-20;
  If 30-axis_width-2<0 Then SignalVScr.Canvas.TextOut(2,y1-12,axis_label)
  Else SignalVScr.Canvas.TextOut(30-axis_width-2,y1-12,axis_label);

  stepx:=(SignalVScr.Width-4-30-6) div 8;
  y1:=4; y2:=SignalVScr.Height-20;

  For i:=0 To 8 Do Begin
    x1:=33+i*stepx;
    x2:=x1;
    SignalVScr.Canvas.MoveTo(x1,y1);
    SignalVScr.Canvas.LineTo(x2,y2);
    //axis_label:=FormatFloat('#.#', xaxislabel_from1+Round( (i-1)*(xaxislabel_to1-xaxislabel_from1)/8 ) );
    axis_label:=FormatFloat('0.#', xaxislabel_from1+(i-1)*(xaxislabel_to1-xaxislabel_from1)/8 );
    axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
    x1:=33+(i-1)*stepx;
    SignalVScr.Canvas.TextOut(x1-(axis_width div 2),y2+4,axis_label);
  End;
  i:=9;
  axis_label:=FormatFloat('0.#', xaxislabel_to1);
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  x1:=30+(i-1)*stepx;
  SignalVScr.Canvas.TextOut(x1-axis_width+5,y2+4,axis_label);

  y1:=SignalVScr.Height-20-4*stepy;
  SignalVScr.Canvas.Brush.Color:=clBlack;
  SignalVscr.Canvas.FillRect(Rect(35,y1,SignalVscr.Width-9,y1+16));

  y1:=4; y2:=SignalVScr.Height-20-5-4*stepy;

  For i:=0 To 8 Do Begin
    x1:=33+i*stepx;
    x2:=x1;
    SignalVScr.Canvas.MoveTo(x1,y1);
    SignalVScr.Canvas.LineTo(x2,y2);
    //axis_label:=FormatFloat('#.#', xaxislabel_from2+Round( (i-1)*(xaxislabel_to2-xaxislabel_from2)/8 ) );
    axis_label:=FormatFloat('0.#', xaxislabel_from2+(i-1)*(xaxislabel_to2-xaxislabel_from2)/8 );
    axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
    If i=1 Then Begin
      x1:=35+(i-1)*stepx;
      SignalVScr.Canvas.TextOut(x1,y2+4,axis_label);
    End Else Begin
      x1:=33+(i-1)*stepx;
      SignalVScr.Canvas.TextOut(x1-(axis_width div 2),y2+4,axis_label);
    End;
  End;
  i:=9;
  axis_label:=FormatFloat('0.#', xaxislabel_to2);
  axis_width:=SignalVScr.Canvas.TextWidth(axis_label);
  x1:=30+(i-1)*stepx;
  SignalVScr.Canvas.TextOut(x1-axis_width+5,y2+4,axis_label);

  y1:=SignalVScr.Height-20-3-4*stepy;
  SignalVScr.Canvas.Pen.Color:=RGB(221,134,38);
  SignalVscr.Canvas.Pen.Style:=psSolid;
  SignalVScr.Canvas.MoveTo(30,y1);
  SignalVScr.Canvas.LineTo(SignalVScr.Width-6,y1);

  SignalVScr.Canvas.Pen.Color:=RGB(221,134,38);
  SignalVscr.Canvas.Pen.Style:=psSolid;

  sx1:=33; sx2:=33+8*stepx;
  sy1:=7;  sy2:=7+8*stepy;
End;

Procedure TMainForm.UpdateSignalScreen;
Var
  i:Integer;
Begin
  If Not OverWriteCheckBox.Checked then Begin
    SignalVScr.Canvas.Brush.Color:=clBlack;
    SignalVScr.Canvas.FillRect(Rect(0,0,SignalVScr.Width,SignalVScr.Height));
  End;

  If Channel1RadioButton.Checked Then Begin
    If AutoScaleCheckBox.Checked Then DrawAxis(SignalVScr,ActiveBank*BankLen+BankOffset+_offset,(ActiveBank+1)*BankLen-1+BankOffset+_offset+1,ReallMin0,ReallMax0,true)
    Else DrawAxis(SignalVScr,ActiveBank*BankLen+BankOffset+_offset,(ActiveBank+1)*BankLen-1+BankOffset+_offset+1,-signal_zerolevel/SignalScaleYCoefficient,signal_zerolevel/SignalScaleYCoefficient,false);
    PaintRealArray(@RealDataArray_Chn0,clRed,Rect(sx1,sy1+3,sx2,sy2));
  End Else If Channel2RadioButton.Checked Then Begin
    If AutoScaleCheckBox.Checked Then DrawAxis(SignalVScr,ActiveBank*BankLen+BankOffset+_offset,(ActiveBank+1)*BankLen-1+BankOffset+_offset+1,ReallMin1,ReallMax1,true)
    Else DrawAxis(SignalVScr,ActiveBank*BankLen+BankOffset+_offset,(ActiveBank+1)*BankLen-1+BankOffset+_offset+1,-signal_zerolevel/SignalScaleYCoefficient,signal_zerolevel/SignalScaleYCoefficient,false);
    PaintRealArray(@RealDataArray_Chn1,clLime,Rect(sx1,sy1+3,sx2,sy2));
  End Else If Channel12RadioButton.Checked Then Begin
    If AutoScaleCheckBox.Checked Then DrawAxis2(SignalVScr,ActiveBank*BankLen+BankOffset+_offset1,(ActiveBank+1)*BankLen-1+BankOffset+_offset1+1,ActiveBank*BankLen+BankOffset+_offset2,(ActiveBank+1)*BankLen-1+BankOffset+_offset2+1,ReallMin1,ReallMax1,ReallMin0,ReallMax0,true)
    Else DrawAxis2(SignalVScr,ActiveBank*BankLen+BankOffset+_offset1,(ActiveBank+1)*BankLen-1+BankOffset+_offset1+1,ActiveBank*BankLen+BankOffset+_offset2,(ActiveBank+1)*BankLen-1+BankOffset+_offset2+1,-signal_zerolevel/SignalScaleYCoefficient,signal_zerolevel/SignalScaleYCoefficient,-signal_zerolevel/SignalScaleYCoefficient,signal_zerolevel/SignalScaleYCoefficient,false);
    PaintRealArray(@RealDataArray_Chn0,clGreen,Rect(sx1,sy1+3,sx2,((sy2-sy1+1) div 2)+8));
    PaintRealArray(@RealDataArray_Chn1,clBlue,Rect(sx1,((sy2-sy1+1) div 2)+11,sx2,sy2));
  End Else If ChannelSubRadioButton.Checked Then Begin
    For i:=0 To ADCBufLen Do
      RealDataArray_ChnSub[i]:=RealDataArray_Chn1[i]-RealDataArray_Chn0[i];
    If AutoScaleCheckBox.Checked Then DrawAxis(SignalVScr,ActiveBank*BankLen+BankOffset+_offset,(ActiveBank+1)*BankLen-1+BankOffset+_offset+1,ReallMin0,ReallMax0,true)
    Else DrawAxis(SignalVScr,ActiveBank*BankLen+BankOffset+_offset,(ActiveBank+1)*BankLen-1+BankOffset+_offset+1,-signal_zerolevel/SignalScaleYCoefficient,signal_zerolevel/SignalScaleYCoefficient,false);
    PaintRealArray(@RealDataArray_ChnSub,clPurple,Rect(sx1,sy1+3,sx2,sy2));
  End;

End;

Procedure TMainForm.UpdateDACScreen;
Begin
  SignalVScr.Canvas.Brush.Color:=clBlack;
  SignalVScr.Canvas.FillRect(Rect(0,0,SignalVScr.Width,SignalVScr.Height));
  FindLocalMinMax(@DACArray,DACActiveBank,DACBankLen,false);
  DACReallMin:=RealMin; DACReallMax:=RealMax;
  If DACAutoScaleCheckBox.Checked Then DrawAxis(SignalVScr,DACActiveBank*DACBankLen+BankOffset,(DACActiveBank+1)*DACBankLen-1+BankOffset+1,DACReallMin,DACReallMax,true)
  Else DrawAxis(SignalVScr,DACActiveBank*DACBankLen+BankOffset,(DACActiveBank+1)*DACBankLen-1+BankOffset+1,-dac_maxamp-1,dac_maxamp+1,false);
  DACPaintRealArray(@DACArray,clBlue,Rect(sx1,sy1+3,sx2,sy2));
End;

Procedure TMainForm.UpdateStatisticScreen;
Begin
  If CalculateStatisticCheckBox.Checked Then CalculateStatistic;
  If CalculateHistogramCheckBox.Checked Then CalcHistograms;
  DrawHistograms;
End;

Procedure TMainForm.UpdateScreen;
Begin
  FindLocalMinMax(@RealDataArray_Chn0,ActiveBank,BankLen,true);
  ReallMin0:=RealMin; ReallMax0:=RealMax; _offset1:=_offset;
  FindLocalMinMax(@RealDataArray_Chn1,ActiveBank,BankLen,true);
  ReallMin1:=RealMin; ReallMax1:=RealMax; _offset2:=_offset;
  if CalcGlobalMinMax.Checked = true then
  Begin
     FindGlobalMinMax;
     Ch1GlobMinEdit.Text:=FloatToStr(GlobalMin0);
     Ch1GlobMaxEdit.Text:=FloatToStr(GlobalMax0);
     Ch2GlobMinEdit.Text:=FloatToStr(GlobalMin1);
     Ch2GlobMaxEdit.Text:=FloatToStr(GlobalMax1);
  End;
  
  Ch1LocalMinEdit.Text:=FloatToStr(ReallMin0); Ch1LocalMaxEdit.Text:=FloatToStr(ReallMax0);
  Ch2LocalMinEdit.Text:=FloatToStr(ReallMin1); Ch2LocalMaxEdit.Text:=FloatToStr(ReallMax1);

  SynchroOffset1Edit.Text:=IntToStr(_offset1);
  SynchroOffset2Edit.Text:=IntToStr(_offset2);

  Case SignalsPageControl.ActivePageIndex Of
    0: UpdateSignalScreen;
    1: UpdateDACScreen;
    2: UpdateStatisticScreen;
  End;
  If (Zoom_Allow)And(Zoom_BeginDrag)And(SignalsPageControl.ActivePageIndex<>3) Then Begin
    SignalVScr.Canvas.Pen.Color:=clWhite;
    SignalVScr.Canvas.MoveTo(Zoom_X1,sy1);
    SignalVScr.Canvas.LineTo(Zoom_X1,sy2);
    SignalVScr.Canvas.MoveTo(Zoom_X2,sy1);
    SignalVScr.Canvas.LineTo(Zoom_X2,sy2);
  End;
  BankOffsetLabel.Caption:=IntToStr(BankOffset);
End;

Procedure TMainForm.FlipToScr;
Begin
  SignalPaintBox.Canvas.Lock;
  SignalPaintBox.Canvas.Draw(0,0,SignalVScr);
  SignalPaintBox.Canvas.Unlock;
  Application.ProcessMessages;
End;

Procedure TMainForm.StartButtonClick(Sender: TObject);
Begin
  CycleFromLStartCount:=0;
  CycFromLastStartValue.Caption:='0';
  TimeoutFromLStartCount:=0;
  StartButton.Enabled:=False;
  StopButton.Enabled:=True;

  SamplingStatusEdit.Text:='';

  AverageNumber := StrToInt(AverageNumberEdit.Text);
  AverageCount :=0;

  If OnetimeRadioButton.Checked Then F_Stop:=True Else F_Stop:=False;
  SignalThread.Resume;
End;

Procedure TMainForm.StopButtonClick(Sender: TObject);
Begin
  F_Stop:=True;
  MainForm.StopButton.Enabled:=False;
End;

Procedure TMainForm.DevicePageControlChange(Sender: TObject);
Begin
  active_device:=DevicePageControl.ActivePageIndex;
  DACEnableCheckBox.Checked:=False;
  XdspDACDisable(XDspDevices[active_device].DeviceHandle);
  AddrCntrTestCheckBox.Checked:=False;
  XdspAddrCntrToADCDataDisable(XDspDevices[active_device].DeviceHandle);
  ExtStartCheckBox.Checked:=False;
  XdspExternalStartDisable(XDspDevices[active_device].DeviceHandle);
  IntrWaitTimeOut:=100;

  Case active_device Of
     1: Begin Device0Devices.Checked:=true; Device1Devices.Checked:=false; Device2Devices.Checked:=false; Device3Devices.Checked:=false; End;
     2: Begin Device0Devices.Checked:=false; Device1Devices.Checked:=true; Device2Devices.Checked:=false; Device3Devices.Checked:=false; End;
     3: Begin Device0Devices.Checked:=false; Device1Devices.Checked:=false; Device2Devices.Checked:=true; Device3Devices.Checked:=false; End;
     4: Begin Device0Devices.Checked:=false; Device1Devices.Checked:=false; Device2Devices.Checked:=false; Device3Devices.Checked:=true; End;
  End;
End;

Procedure TMainForm.ADC_ModelData;
Var
  i:integer;
  dwData:DWord;
  Chn1Value:SmallInt; Chn2Value:SmallInt;
  amp,phase:Real;
Begin
  amp:=4096; phase:=-1+random(200)/100;
  For i:=0 to ADCBufLen Do Begin
    RealDataArray_Chn0[i] := Round(amp*Sin(phase+i*2*Pi*(1000000{+random(100000)})/FREQDISCRETE_HZ));
    RealDataArray_Chn1[i] := Round(amp*Sin(phase+i*2*Pi*(6000000{+random(100000)})/FREQDISCRETE_HZ));
  End;

End;

Procedure TMainForm.ADC_ReadData;
Var
  i:integer;
  wData1:Word;
  wData2:Word;
  //ChnValue:DWord; Chn1Value:SmallInt; Chn2Value:SmallInt;
Begin
  RealgMin0:=65535;
  RealgMax0:=-65535;
  RealgMin1:=65535;
  RealgMax1:=-65535;

//  For i:=0 to ADCBufLen Do
//  Begin
//    // Read memory directly from DMA Buffer
//    wData1:=XdspDevices[active_device].DMABuffer1^[i+1];
//    wData2:=XdspDevices[active_device].DMABuffer2^[i+1];

    if AverageCheckBox.Checked then
      begin
        if AverageCount=0 then
          begin
            For i:=0 to ADCBufLen Do
               Begin
                // Read memory directly from DMA Buffer
                 wData1:=XdspDevices[active_device].DMABuffer1^[i+1];
                 wData2:=XdspDevices[active_device].DMABuffer2^[i+1];
                 RealDataArray_Chn0[i]:=SmallInt(wData1);
                 RealDataArray_Chn1[i]:=SmallInt(wData2);
               End
          end
        else
          begin
            For i:=0 to ADCBufLen Do
               Begin
                // Read memory directly from DMA Buffer
                 wData1:=XdspDevices[active_device].DMABuffer1^[i+1];
                 wData2:=XdspDevices[active_device].DMABuffer2^[i+1];
                 RealDataArray_Chn0[i]:=RealDataArray_Chn0[i]+SmallInt(wData1);
                 RealDataArray_Chn1[i]:=RealDataArray_Chn1[i]+SmallInt(wData2);
               End;
          end;
      end
     else
       begin
            For i:=0 to ADCBufLen Do
               Begin
                // Read memory directly from DMA Buffer
                 wData1:=XdspDevices[active_device].DMABuffer1^[i+1];
                 wData2:=XdspDevices[active_device].DMABuffer2^[i+1];
                 RealDataArray_Chn0[i]:=SmallInt(wData1);
                 RealDataArray_Chn1[i]:=SmallInt(wData2);
                 If wData1>RealgMax0 Then RealgMax0:=wData1;
                 If wData1<RealgMin0 Then RealgMin0:=wData1;
                 If wData2>RealgMax1 Then RealgMax1:=wData2;
                 If wData2<RealgMin1 Then RealgMin1:=wData2;
               End;
       end;


//  End;
End;

Procedure TMainForm.ADC_NormalizeData;
Var
  i:integer;
Begin
//  RealgMin0:=65535;
//  RealgMax0:=-65535;
//  RealgMin1:=65535;
//  RealgMax1:=-65535;

  For i:=0 to ADCBufLen Do
  Begin
          RealDataArray_Chn0[i]:=RealDataArray_Chn0[i]/AverageNumber;
          RealDataArray_Chn1[i]:=RealDataArray_Chn1[i]/AverageNumber;
//     If RealDataArray_Chn0[i]>RealgMax0 Then RealgMax0:=RealDataArray_Chn0[i];
//     If RealDataArray_Chn0[i]<RealgMin0 Then RealgMin0:=RealDataArray_Chn0[i];
//     If RealDataArray_Chn1[i]>RealgMax1 Then RealgMax1:=RealDataArray_Chn1[i];
//     If RealDataArray_Chn1[i]<RealgMin1 Then RealgMin1:=RealDataArray_Chn1[i];
  end;
  
End;

Procedure TMainForm.PaintLine(Canvas:TCanvas;x0,y0,x1,y1:integer);
Begin
  Canvas.MoveTo(x0,y0);
  Canvas.LineTo(x1,y1);
End;

Procedure TMainForm.PaintDot(Canvas:TCanvas;x0,y0:integer);
Begin
  Canvas.MoveTo(x0,y0);
  Canvas.LineTo(x0,y0);
End;

Procedure TMainForm.PaintRealArray(A:TRealA;_Color:TColor;draw_rect:TRect);
Var i,j,x0,y0,y1,blankpos,cntr:Integer;
    temp:Real;
   _divisor:Real;

    sx1,sy1,sx2,sy2:Integer;
    paintX0,paintX1,paintY0,paintY1 : Integer;
    lastx,lasty : Integer;
    swidth,sheight:Integer;

Procedure FindSynchroLabelFalling;
Var i,j,j1{,n}:integer;
Begin
   _offset:=0;{n:=0;}
   For i:=0 To ADCBufLen Do Begin
       j:=ActiveBank*BankLen+i; If j>ADCBufLen Then exit;
       If A[j]*SignalScaleYCoefficient>SynchroLevel*128 Then Begin
          {inc(n);if n>SynchroGister Then }break;
       End{ Else n:=0};
   End;
   If i=ADCBufLen Then exit;
  _offset:=i;{n:=0;}
   For i:=_offset To ADCBufLen Do Begin
       j:=ActiveBank*BankLen+i;
       If j>ADCBufLen Then Begin
          _offset:=0;exit;
       End;
       If A[j]*SignalScaleYCoefficient<SynchroLevel*128 Then Begin
         j1:=j;
         While(A[j1]=A[j]*SignalScaleYCoefficient) Do Inc(j);
         {inc(n);
         If n=SynchroGister Then Begin}
          _offset:=j-ActiveBank*BankLen{-SynchroGister};exit;
         {End;}
       End{ Else n:=0};
   End;
   _offset:=0;
End;

procedure FindSynchroLabelRising;
var i,j,n:integer;
begin
   _offset:=0;n:=0;
   for i:=0 to ADCBufLen do begin
       j:=ActiveBank*BankLen+i;
       if j>ADCBufLen then exit;
       if A[j]*SignalScaleYCoefficient>SynchroLevel*128 then begin
          inc(n);
          if n>SynchroGister then begin
             _offset:=i-SynchroGister;exit;
          end;
       end else n:=0;
   end;
   _offset:=0;
end;

Var
  _off:Double;
begin
  sx1:=draw_rect.Left; sy1:=draw_rect.Top;
  sx2:=draw_rect.Right; sy2:=draw_rect.Bottom;
  swidth:=sx2-sx1; sheight:=sy2-sy1;
 _stepx:=swidth/(BankLen-1);

  RealMin:=32767; RealMax:=-32767; _off:=0;

  SynchroLevel:=(16-SynchroLevelTrackBar.Position);

  If SynchroCheckBox.Checked Then Begin
    If SynchroRisingEdgeRadioButton.Checked Then FindSynchroLabelRising
    Else FindSynchroLabelFalling;

    //----test cluster begin!!!--------
    _offset:=_offset-_PaintDly;
    // if _offset>__PaintDly then offset:=_offset-_PaintDly;
    //----test cluster end!!!------------

    With SignalVScr Do Begin
      Canvas.Pen.Color:=clred;
      paintX0 := sx1; paintX1 := sx2;
      paintY0 := sy1+Trunc(SynchroLevelTrackBar.Position*(sheight/32)); paintY1 := sy1+Trunc(SynchroLevelTrackBar.Position*(sheight/32));
      if ((paintX0 <> paintX1) or (paintY0 <> paintY1)) then
         PaintLine(Canvas,paintX0,paintY0,paintX1,paintY1);
    End;

   If ActiveBank*BankLen+_offset-2>0 Then
   If A[ActiveBank*BankLen+_offset-2]-A[ActiveBank*BankLen+_offset-1]<>0 Then
   _off:=(SynchroLevel*128-A[ActiveBank*BankLen+_offset-2])/(A[ActiveBank*BankLen+_offset-2]-A[ActiveBank*BankLen+_offset-1]);
   //_off:=0;
   //Status1Label.Caption:=FormatFloat('#.####',_off);
  End Else _offset:=0;

  // autoscale mode not selected -----------------------------------
  If Not AutoScaleCheckBox.Checked Then Begin
    With SignalVScr Do Begin
      //draw zerro line
      Canvas.Pen.Color:=RGB(221,134,38);
      Canvas.Pen.Style:=psSolid;
      paintX0 := sx1-2; paintX1 := sx2;
      paintY0 := sy1+(sheight div 2); paintY1 := sy1+(sheight div 2);
      if ((paintX0 <> paintX1) or (paintY0 <> paintY1)) then
         PaintLine(Canvas,paintX0,paintY0,paintX1,paintY1);

      Canvas.Pen.Color:=_color;

      _divisor:=sheight/signal_range;

      //----test cluster begin!!!-----------
      If _offset<0 then begin
        blankpos:=abs(_offset);_offset:=0;
      end else blankpos:=0;
      x0:=Trunc(blankpos*_stepx)+round(_off*_stepx);
      j:=BankLen*ActiveBank+_offset+BankOffset;
      //----test cluster end!!!------------

      If j>ADCBufLen then temp:=0 else temp:=A[j]*SignalScaleYCoefficient;
      y0:=Trunc(abs(temp-signal_zerolevel)*_divisor);
      RealMin:=temp;RealMax:=temp;

      i:=1;
      lastx := 0;  lasty := 0;
      For Cntr:=Blankpos+1 To BankLen do begin
        j:=i+BankLen*ActiveBank+_offset+BankOffset;
        If j>ADCBufLen then {temp:=0}Break else temp:=A[j]*SignalScaleYCoefficient;
        If temp>signal_zerolevel Then temp:=signal_zerolevel;
        If temp<-signal_zerolevel Then temp:=-signal_zerolevel;
        y1:=Trunc(abs(temp-signal_zerolevel)*_divisor);
        If x0>=0 Then Begin
        If SignalDrawDotsCheckBox.Checked Then
           begin
              paintX0 := sx1+x0; paintY0 := sy1+y0;
              if ((lastx <> paintX0) or (lasty <> paintY0)) then
              begin
                 PaintDot(Canvas,paintX0,paintY0);
                 lastx := paintX0; lasty := paintY0;
              end;

           end
        Else
           begin
              paintX0 := sx1+x0; paintX1 := sx1+round(_off*_stepx)+trunc(cntr*_stepx);
              paintY0 := sy1+y0; paintY1 := sy1+y1;
              if ((paintX0 <> paintX1) or (paintY0 <> paintY1)) then
                 PaintLine(Canvas,paintX0,paintY0,paintX1,paintY1);
           end;
        End;
        x0:=round(_off*_stepx)+trunc(cntr*_stepx);y0:=y1;
        i:=i+1;
        If temp>RealMax then RealMax:=temp;
        If temp<RealMin then RealMin:=temp;
      End;
    End;{With}
  // END autoscale mode not selected -------------------------------
  End Else Begin
  // autoscale mode selected ---------------------------------------

    // looking for MAX and MIN--
    j:=BankLen*ActiveBank+_offset+BankOffset;
    If j>ADCBufLen then temp:=0 Else temp:=A[j];
    RealMin:=temp;RealMax:=temp;
    For i:=1 To BankLen-1 Do Begin
      j:=i+BankLen*ActiveBank+_offset+BankOffset;
      If j<=ADCBufLen Then temp:=A[j];
      If temp>RealMax Then RealMax:=temp;
      If temp<RealMin Then RealMin:=temp;
    End;

    temp:=abs(RealMax-RealMin);
    if temp<>0 then _divisor:=sheight/temp else _divisor:=1;

    With SignalVScr Do Begin
      y0:=round(RealMax*_divisor);
      Canvas.Pen.Color:=RGB(221,134,38);
      Canvas.Pen.Style:=psSolid;
      If (sy1+y0>sy1)And(sy1+y0<sheight) Then
      begin
         paintX0 := sx1-2; paintX1 := sx1+swidth;
         paintY0 := sy1+y0; paintY1 := sy1+y0;
         if ((paintX0 <> paintX1) or (paintY0 <> paintY1)) then
            PaintLine(Canvas,paintX0,paintY0,paintX1,paintY1);
      end;

      Canvas.Pen.Color:=_color;
      x0:=round(_off*_stepx);;j:=BankLen*ActiveBank+_offset+BankOffset;
      If j>ADCBufLen then temp:=0 else temp:=A[j];
      y0:=abs(round((temp-RealMax)*_divisor));
      For i:=1 To BankLen-1 Do Begin
        j:=i+BankLen*ActiveBank+_offset+BankOffset;
        If j>ADCBufLen Then {temp:=0}Break Else temp:=A[j];
        y1:=abs(round((temp-RealMax)*_divisor));
        If x0>=0 Then Begin
        If SignalDrawDotsCheckBox.Checked Then PaintDot(Canvas,sx1+x0,sy1+y0)
        Else begin
                paintX0 := sx1+x0; paintX1 := sx1+round(_off*_stepx)+Trunc(I*_stepx);
                paintY0 := sy1+y0; paintY1 := sy1+y1;
                if ((paintX0 <> paintX1) or (paintY0 <> paintY1)) then
                   PaintLine(Canvas,paintX0,paintY0,paintX1,paintY1);
             end;
        End;
        x0:=round(_off*_stepx)+Trunc(i*_stepx);y0:=y1;
      End;
    End;
  End;
End;

Procedure TMainForm.FindGlobalMinMax;
Var
   i:integer;
   temp:Real;
Begin

GlobalMin0 := 32767;
GlobalMax0 := -32767;
GlobalMin1 := 32767;
GlobalMax1 := -32767;

For i:=0 To ADCBufLen Do Begin
   if RealDataArray_Chn0[i] > GlobalMax0 then
       GlobalMax0 := RealDataArray_Chn0[i];
   if RealDataArray_Chn0[i] < GlobalMin0 then
       GlobalMin0 := RealDataArray_Chn0[i];
   if RealDataArray_Chn1[i] > GlobalMax1 then
       GlobalMax1 := RealDataArray_Chn1[i];
   if RealDataArray_Chn1[i] < GlobalMin1 then
       GlobalMin1 := RealDataArray_Chn1[i];
End;
End;

Procedure TMainForm.FindLocalMinMax(A:TRealA; ActiveBank_:Integer; BankLen_:Integer; synchro:Boolean);
Var i,j:Integer;
    temp:Real;

Procedure FindSynchroLabelFalling;
Var i,j,n:integer;
Begin
   _offset:=0;n:=0;
   For i:=0 To ADCBufLen Do Begin
       j:=ActiveBank_*BankLen_+i; If j>ADCBufLen Then exit;
       If A[j]>SynchroLevel*128 Then Begin
          inc(n);if n>SynchroGister Then break;
       End Else n:=0;
   End;
   If i=ADCBufLen Then exit;_offset:=i;n:=0;
   For i:=_offset To ADCBufLen Do Begin
       j:=ActiveBank_*BankLen_+i;
       If j>ADCBufLen Then Begin
          _offset:=0;exit;
       End;
       If A[j]<SynchroLevel*128 Then Begin
         inc(n);
         If n=SynchroGister Then Begin
          _offset:=i-SynchroGister;exit;
         End;
       End Else n:=0;
   End;
  _offset:=0;
End;

procedure FindSynchroLabelRising;
var i,j,n:integer;
begin
   _offset:=0;n:=0;
   for i:=0 to ADCBufLen do begin
       j:=ActiveBank_*BankLen_+i;
       if j>ADCBufLen then exit;
       if A[j]>SynchroLevel*128 then begin
          inc(n);
          if n>SynchroGister then begin
             _offset:=i-SynchroGister;exit;
          end;
       end else n:=0;
   end;
   _offset:=0;
end;

begin
  RealMin:=32767; RealMax:=-32767;

  SynchroLevel:=(16-SynchroLevelTrackBar.Position);

  _offset:=0;

  If synchro Then
  If SynchroCheckBox.Checked Then Begin
    If SynchroRisingEdgeRadioButton.Checked Then FindSynchroLabelRising
    Else FindSynchroLabelFalling;

    //----test cluster begin!!!--------
    _offset:=_offset-_PaintDly;
    // if _offset>__PaintDly then offset:=_offset-_PaintDly;
    //----test cluster end!!!------------
  End;

  // looking for MAX and MIN--
  j:=BankLen_*ActiveBank_+_offset+BankOffset;
  If j>ADCBufLen then temp:=0 Else temp:=A[j];
  RealMin:=temp;RealMax:=temp;
  For i:=1 To BankLen_-1 Do Begin
    j:=i+BankLen_*ActiveBank_+_offset+BankOffset;
    If j<=ADCBufLen Then temp:=A[j];
    If temp>RealMax Then RealMax:=temp;
    If temp<RealMin Then RealMin:=temp;
  End;
End;

Procedure TMainForm.FindLocalMinMax_(A:TA; ActiveBank_:Integer; BankLen_:Integer; synchro:Boolean);
Var i,j:Integer;
    temp:Integer;

begin
  RealMin:=32767; RealMax:=-32767;

  _offset:=0;

  // looking for MAX and MIN--
  j:=BankLen_*ActiveBank_+_offset+BankOffset;
  If j>ADCBufLen then temp:=0 Else temp:=A[j];
  RealMin:=temp;RealMax:=temp;
  For i:=1 To BankLen_-1 Do Begin
    j:=i+BankLen_*ActiveBank_+_offset+BankOffset;
    If j<=ADCBufLen Then temp:=A[j];
    If temp>RealMax Then RealMax:=temp;
    If temp<RealMin Then RealMin:=temp;
  End;
End;

procedure TMainForm.BankSizeComboBoxChange(Sender: TObject);
begin
  If BankSizeComboBox.Text<>'' Then
  If (StrToInt(BankSizeComboBox.Text)>1)And(StrToInt(BankSizeComboBox.Text)<=XDSP_BOARD_MEMORY) Then Begin
  //BankOffset:=0;
  BankLen:=StrToInt(BankSizeComboBox.Text);
  ViewBankScrollBar.Max:=(XDSP_BOARD_MEMORY div BankLen)-1;
  If BankLen*ActiveBank>XDSP_BOARD_MEMORY Then ActiveBank:=(XDSP_BOARD_MEMORY div BankLen)-1;
  Refresh;
  UpdateScreen;
  FlipToScr;
//  UpdateSignalScreen;
//  FlipToScr;
  End;
end;

procedure TMainForm.ViewBankScrollBarChange(Sender: TObject);
begin
  //BankOffset:=0;
  ActiveBank:=ViewBankScrollBar.Position;
  ActiveBankLabel.Caption:=IntToStr(ActiveBank);
  Refresh;
  UpdateScreen;
  FlipToScr;
//  UpdateSignalScreen;
//  FlipToScr;
end;

procedure TMainForm.ClearDrawingAreaButtonClick(Sender: TObject);
begin
  SignalVScr.Canvas.Brush.Color:=clBlack;
  SignalVScr.Canvas.FillRect(Rect(0,0,SignalVScr.Width,SignalVScr.Height));
  FlipToScr;
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
  refresh_screen:=True;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
Var i:Integer;
begin
  For i:=1 To 4 Do Begin
    Case i Of
      1: If Device0Devices.Checked Then Begin
           XdspCloseDevice(XdspDevices[i-1].DeviceHandle);
           Registry.WriteBool('XdspDevice0Busy',False);
         End;
      2: If Device1Devices.Checked Then Begin
           XdspCloseDevice(XdspDevices[i-1].DeviceHandle);
           Registry.WriteBool('XdspDevice1Busy',False);
         End;
      3: If Device2Devices.Checked Then Begin
           XdspCloseDevice(XdspDevices[i-1].DeviceHandle);
           Registry.WriteBool('XdspDevice2Busy',False);
         End;
      4: If Device3Devices.Checked Then Begin
           XdspCloseDevice(XdspDevices[i-1].DeviceHandle);
           Registry.WriteBool('XdspDevice3Busy',False);
         End;
    End;
  End;
end;

procedure TMainForm.SignalsPageControlChange(Sender: TObject);
begin
  If SignalsPageControl.ActivePageIndex=2 Then Begin
    StatisticPanel.Visible:=True;
    Refresh;
  End Else Begin
    StatisticPanel.Visible:=False;
    Refresh;
    UpdateScreen;
    FlipToScr;
  End;
  Case SignalsPageControl.ActivePageIndex Of
    0: PropPageControl.ActivePageIndex:=0;
    1: PropPageControl.ActivePageIndex:=4;
    2: PropPageControl.ActivePageIndex:=2;
  End;
end;

procedure TMainForm.DACEnableCheckBoxClick(Sender: TObject);
var i : integer;
begin
for i :=1 to dev_count do begin
  If DACEnableCheckBox.Checked Then XdspDACEnable(XDspDevices[i].DeviceHandle)
  Else XdspDACDisable(XDspDevices[i].DeviceHandle);

end;
end;

procedure TMainForm.AddrCntrTestCheckBoxClick(Sender: TObject);
var i : integer;
begin
for i :=1 to dev_count do begin
  If AddrCntrTestCheckBox.Checked Then XdspAddrCntrToADCDataEnable(XDspDevices[i].DeviceHandle)
  Else XdspAddrCntrToADCDataDisable(XDspDevices[i].DeviceHandle);
end;
end;

procedure TMainForm.ExtStartCheckBoxClick(Sender: TObject);
var i : integer;
begin
for i :=1 to dev_count do begin
  If ExtStartCheckBox.Checked Then Begin
    XdspExternalStartEnable(XDspDevices[i].DeviceHandle);
    IntrWaitTimeOut:=INFINITE;
  End Else Begin
    XdspExternalStartDisable(XDspDevices[i].DeviceHandle);
    IntrWaitTimeOut:=100;
  End;
end;
end;

procedure TMainForm.DACPaintRealArray(A:TRealA;_Color:TColor;draw_rect:TRect);
var i,j,x0,y0,y1,blankpos,cntr:Integer;
    temp:Real;
   _divisor:Real;

    sx1,sy1,sx2,sy2:Integer;
    swidth,sheight:Integer;

begin
  sx1:=draw_rect.Left; sy1:=draw_rect.Top;
  sx2:=draw_rect.Right; sy2:=draw_rect.Bottom;
  swidth:=sx2-sx1; sheight:=sy2-sy1;

  RealMin:=32767; RealMax:=-32767;

  _offset:=0;

  // autoscale mode not selected -----------------------------------
  If Not DACAutoScaleCheckBox.Checked Then Begin
    With SignalVScr Do Begin
      //draw zerro line
      Canvas.Pen.Color:=RGB(221,134,38);
      Canvas.Pen.Style:=psSolid;
      //new control
      if (sx1 <> sx2) or ((sy1+(sheight div 2)) <> sy1+(sheight div 2)) then
         PaintLine(Canvas,sx1,sy1+(sheight div 2),sx2,sy1+(sheight div 2));

      Canvas.Pen.Color:=_color;

      _stepx:=swidth/(DACBankLen-1);
      _divisor:=sheight/dac_range;

      //----test cluster begin!!!-----------
      If _offset<0 then begin
        blankpos:=abs(_offset);_offset:=0;
      end else blankpos:=0;
      x0:=Trunc(blankpos*_stepx);
      j:=DACBankLen*DACActiveBank+_offset+BankOffset;
      //----test cluster end!!!------------

      If j>ADCBufLen then temp:=0 else temp:=A[j];
      y0:=Trunc(abs(temp-dac_zerolevel)*_divisor);
      RealMin:=temp;RealMax:=temp;

      i:=1;
      For Cntr:=Blankpos+1 To DACBankLen-1 do begin
        j:=i+DACBankLen*DACActiveBank+_offset+BankOffset;
        if j>ADCBufLen then temp:=0 else temp:=A[j];
        y1:=Trunc(abs(temp-dac_zerolevel)*_divisor);
        if ((sx1+x0 <> sx1+Trunc(cntr*_stepx)) or (sy1+y0 <> sy1+y1)) then
           PaintLine(Canvas,sx1+x0,sy1+y0,sx1+Trunc(cntr*_stepx),sy1+y1);
        x0:=Trunc(cntr*_stepx);y0:=y1;
        i:=i+1;
        if temp>RealMax then RealMax:=temp;
        if temp<RealMin then RealMin:=temp;
      End;
    End;{With}
  // END autoscale mode not selected -------------------------------
  End Else Begin
  // autoscale mode selected ---------------------------------------

    // looking for MAX and MIN--
    j:=DACBankLen*DACActiveBank+_offset+BankOffset;
    If j>ADCBufLen then temp:=0 Else temp:=A[j];
    RealMin:=temp;RealMax:=temp;
    For i:=1 To DACBankLen-1 Do Begin
      j:=i+DACBankLen*DACActiveBank+_offset+BankOffset;
      If j<=ADCBufLen Then temp:=A[j];
      If temp>RealMax Then RealMax:=temp;
      If temp<RealMin Then RealMin:=temp;
    End;

    temp:=abs(RealMax-RealMin);
    if temp<>0 then _divisor:=(sheight)/temp else _divisor:=1;
    _stepx:=swidth/(DACBankLen-1);

    With SignalVScr Do Begin
      y0:=round(RealMax*_divisor);
      Canvas.Pen.Color:=RGB(221,134,38);
      Canvas.Pen.Style:=psSolid;
      If (sy1+y0>sy1)And(sy1+y0<sheight) Then
      //new control
        If ((sx1+0 <> sx1+swidth) or (sy1+y0 <> sy1+y0)) then
           PaintLine(Canvas,sx1+0,sy1+y0,sx1+swidth,sy1+y0);

      Canvas.Pen.Color:=_color;
      x0:=0;j:=DACBankLen*DACActiveBank+_offset+BankOffset;
      If j>ADCBufLen then temp:=0 else temp:=A[j];
      y0:=abs(round((temp-RealMax)*_divisor));
      For i:=1 To DACBankLen-1 Do Begin
        j:=i+DACBankLen*DACActiveBank+_offset+BankOffset;
        If j>ADCBufLen Then temp:=0 Else temp:=A[j];
        y1:=abs(round((temp-RealMax)*_divisor));
        //new control
        if  ((sx1+x0 <> sx1+Trunc(I*_stepx)) or (sy1+y0 <> sy1+y1)) then
           PaintLine(Canvas,sx1+x0,sy1+y0,sx1+Trunc(I*_stepx),sy1+y1);
        x0:=Trunc(i*_stepx);y0:=y1;
      End;
    End;
  End;
End;

Procedure TMainForm.PaintDINArray(_Color:TColor;draw_rect:TRect);
var i,j,k:Integer;
   _divisor:Real;

    sx1,sy1,sx2,sy2:Integer;
    swidth,sheight:Integer;
Begin
  sx1:=draw_rect.Left; sy1:=draw_rect.Top;
  sx2:=draw_rect.Right; sy2:=draw_rect.Bottom;
  swidth:=sx2-sx1; sheight:=sy2-sy1;

  _stepx:=swidth/(BankLen-1);
  _divisor:=20;

  With SignalVScr Do Begin
    Canvas.Pen.Color:=_Color;
    For k:=1 To 5 Do Begin
    Canvas.MoveTo(sx1,sy1+20+Trunc(_divisor*(k-1)));
    For i:=1 To BankLen-1 Do Begin
      j:=i+BankLen*ActiveBank+_offset+BankOffset;
      If DataArray_DIN[j,k]=1 Then Begin
      Canvas.LineTo(sx1+Trunc((i-1)*_stepx),sy1+20-10+Trunc(_divisor*(k-1)));
      Canvas.LineTo(sx1+Trunc(i*_stepx),sy1+20-10+Trunc(_divisor*(k-1)));
      End
      Else Begin
      Canvas.LineTo(sx1+Trunc((i-1)*_stepx),sy1+20+Trunc(_divisor*(k-1)));
      Canvas.LineTo(sx1+Trunc(i*_stepx),sy1+20+Trunc(_divisor*(k-1)));
      End;
    End;
    End;
  End;
End;

procedure TMainForm.DACBankSizeComboBoxChange(Sender: TObject);
begin
  If DACBankSizeComboBox.Text<>'' Then
  If (StrToInt(DACBankSizeComboBox.Text)>1)And(StrToInt(DACBankSizeComboBox.Text)<=XDSP_BOARD_MEMORY) Then Begin
  //BankOffset:=0;
  DACBankLen:=StrToInt(DACBankSizeComboBox.Text);
  DACViewBankScrollBar.Max:=(XDSP_BOARD_MEMORY div DACBankLen)-1;
  If DACBankLen*DACActiveBank>XDSP_BOARD_MEMORY Then DACActiveBank:=(XDSP_BOARD_MEMORY div DACBankLen)-1;
  UpdateDACScreen;
  FlipToScr;
  End;
end;

procedure TMainForm.DACViewBankScrollBarChange(Sender: TObject);
begin
  //BankOffset:=0;
  DACActiveBank:=DACViewBankScrollBar.Position;
  DACActiveBankLabel.Caption:=IntToStr(DACActiveBank);
  UpdateDACScreen;
  FlipToScr;
end;

Procedure TMainForm.UpdateDACPropPanel;
Begin
  DACVideoImpulsePanel.Visible:=False;
  DACVideoImpulseBurstPanel.Visible:=False;
  DACRadioImpulsePanel.Visible:=False;
  DACRadioImpulseBurstPanel.Visible:=False;
  DACLCHMImpulsePanel.Visible:=False;
  DACBarkerPanel.Visible:=False;
  Case TypeDACSignalComboBox.ItemIndex Of
    0: DACVideoImpulsePanel.Visible:=True;
    1: DACVideoImpulseBurstPanel.Visible:=True;
    2: DACRadioImpulsePanel.Visible:=True;
    3: DACRadioImpulseBurstPanel.Visible:=True;
    4: DACLCHMImpulsePanel.Visible:=True;
    5: DACBarkerPanel.Visible:=True;
  End;
End;

procedure TMainForm.TypeDACSignalComboBoxChange(Sender: TObject);
begin
  UpdateDACPropPanel;
end;

procedure TMainForm.DACGenerateButtonClick(Sender: TObject);
var i,j:Integer;
    Data,REG1 : DWord;

//    data1,data2,data3,data4 : integer;
//    errorRAM3,errorRAM4 : integer;
    status : integer;

begin
  F_Stop:=True;
  Case TypeDACSignalComboBox.ItemIndex Of
    0: GenerateVideoImpulse;
    1: GenerateVideoImpulseBurst;
    2: GenerateRadioImpulse;
    3: GenerateRadioImpulseBurst;
    4: GenerateLCHMImpulse;
    5: GenerateBarkerCode;
  End;
  SignalsPageControl.ActivePageIndex:=1;
  Refresh;
  UpdateScreen;
  FlipToScr;          
  If Application.MessageBox('Load DAC Signal To XdspDevice DAC 1?','',[smbOK]+[smbCancel])=smbOK Then Begin
     for j:=1 to dev_count do Begin
       For i:=0 To ADCBufLen Do  XdspDevices[j].DMABuffer3^[i+1]:=8192 - Trunc(DACArray[i]);

       status := XDspStartWrite(XDspDevices[j].DeviceHandle,2,2,20000);

       if status <> 0 then ShowMessage('Not Load Signal To DAC1');

     end;
  End;

  If Application.MessageBox('Load DAC Signal To XdspDevice DAC2 ?','',[smbOK]+[smbCancel])=smbOK Then Begin
     for j:=1 to dev_count do Begin
       For i:=0 To ADCBufLen Do  XdspDevices[j].DMABuffer4^[i+1]:=8192 - Trunc(DACArray[i]);

       status := XDspStartWrite(XDspDevices[j].DeviceHandle,3,3,20000);
       
       if status <> 0 then ShowMessage('Not Load Signal To DAC2');
     end;
  End;
end;

procedure TMainForm.DACAutoScaleCheckBoxClick(Sender: TObject);
begin
  UpdateDACScreen;
  FlipToScr;
end;

procedure TMainForm.GenerateVideoImpulse;
var
  BeginImpStr,EndImpStr, AmplMinStr,AmplMaxStr : string;
  i,BeginImp,EndImp : Longint;
  AmplMin,AmplMax : smallint;
begin
  BeginImpStr := Trim(VideoImpulseSignalBeginEdit.Text);
  EndImpStr   := Trim(VideoImpulseSignalEndEdit.Text);
  AmplMinStr  := Trim(VideoImpulseSignalOffsetEdit.Text);
  AmplMaxStr  := Trim(VideoImpulseAmplifireEdit.Text);

  If (BeginImpStr='') Or (EndImpStr='') Or
     ( AmplMinStr='') Or ( AmplMaxStr='') Then Begin
      ShowMessage('Error in inpute data');
  End Else Begin
    BeginImp:=StrToInt(BeginImpStr);
    EndImp:=StrToInt(EndImpStr);
    AmplMin:=StrToInt(AmplMinStr);
    AmplMax:=StrToInt(AmplMaxStr);

    For i:=0 To BeginImp Do Begin PatternArray[i]:=AmplMin;DACArray[i]:=AmplMin;End;
    For i:=BeginImp To EndImp Do Begin PatternArray[i]:=AmplMax;DACArray[i]:=AmplMax;End;
    For i:=(EndImp+1) To ADCBufLen Do Begin PatternArray[i]:=AmplMin;DACArray[i]:=AmplMin;End;
  End
End;

procedure TMainForm.GenerateVideoImpulseBurst;
var
  i,j,k,NachVideoPachka,DlitImpVideoPachka,
  PauseImpVideoPachka,
  KolImpVideoPachka : longint;
  MinAmplImpVideoPachka,
  MaxAmplImpVideoPachka : smallint;
  NachVideoPachkaStr,DlitImpVideoPachkaStr,
  PauseImpVideoPachkaStr,
  KolImpVideoPachkaStr,
  MinAmplImpVideoPachkaStr,
  MaxAmplImpVideoPachkaStr : string;
begin
  NachVideoPachkaStr:=Trim(VideoImpulseBurstSignalBeginEdit.Text);
  DlitImpVideoPachkaStr:=Trim(VideoImpulseBurstImpulseLengthEdit.Text);
  PauseImpVideoPachkaStr:=Trim(VideoImpulseBurstBetwenImpulsesEdit.Text);
  KolImpVideoPachkaStr:=Trim(VideoImpulseBurstImpulsesNumberEdit.Text);
  MinAmplImpVideoPachkaStr:=Trim(VideoImpulseBurstSignalOffsetEdit.Text);
  MaxAmplImpVideoPachkaStr:=Trim(VideoImpulseBurstAmplifireEdit.Text);

  If (NachVideoPachkaStr='') or (DlitImpVideoPachkaStr='') or
     (PauseImpVideoPachkaStr='') or (KolImpVideoPachkaStr='') or
     (MinAmplImpVideoPachkaStr='') or (MaxAmplImpVideoPachkaStr='') Then ShowMessage('Error in inpute data')
  Else Begin
    NachVideoPachka:=StrToInt(NachVideoPachkaStr);
    DlitImpVideoPachka:=StrToInt(DlitImpVideoPachkaStr);
    PauseImpVideoPachka:=StrToInt(PauseImpVideoPachkaStr);
    KolImpVideoPachka:=StrToInt(KolImpVideoPachkaStr);
    MinAmplImpVideoPachka:=StrToInt(MinAmplImpVideoPachkaStr);
    MaxAmplImpVideoPachka:=StrToInt(MaxAmplImpVideoPachkaStr);

    For i:=0 to NachVideoPachka do begin PatternArray[i]:=MinAmplImpVideoPachka;DACArray[i]:=MinAmplImpVideoPachka;end;

    k:=NachVideoPachka;
    For j:=1 to KolImpVideoPachka do
    begin
      for i:=k to k+DlitImpVideoPachka-1 do begin PatternArray[i]:=MaxAmplImpVideoPachka;DACArray[i]:=MaxAmplImpVideoPachka;end;
      k:=k+DlitImpVideoPachka;
      for i:=k to k+PauseImpVideoPachka-1 do begin PatternArray[i]:=MinAmplImpVideoPachka;DACArray[i]:=MinAmplImpVideoPachka;end;
      k:=k+PauseImpVideoPachka;
    end;
    For i:=k to ADCBufLen do begin PatternArray[i]:=MinAmplImpVideoPachka;DACArray[i]:=MinAmplImpVideoPachka;end;
  End
end;

function GeneratorSin(Freq,n : longint):Extended;
begin
Result:=sin(Freq*2*Pi*n/FREQDISCRETE_HZ)
end;

procedure TMainForm.GenerateRadioImpulse;
var
  BeginRadioImpStr,
  EndRadioImpStr,
  FreqRadioImpStr,
  OffsetRadioImpStr,
  MaxRadioImpStr: string;
  i,
  BeginRadioImp,
  EndRadioImp,
  FreqRadioImp : longint;
  OffsetRadioImp,
  MaxRadioImp : smallint;

begin
  BeginRadioImpStr:=Trim(RadioImpulseSignalBeginEdit.Text);
  EndRadioImpStr:=Trim(RadioImpulseSignalEndEdit.Text);
  FreqRadioImpStr:=Trim(RadioImpulseFrequencyEdit.Text);
  OffsetRadioImpStr:=Trim(RadioImpulseSignalOffsetEdit.Text);
  MaxRadioImpStr:=Trim(RadioImpulseAmplifireEdit.Text);

  if (BeginRadioImpStr='') or (EndRadioImpStr='') or
     (FreqRadioImpStr='')  or  (OffsetRadioImpStr='') or
     (MaxRadioImpStr='')   Then ShowMessage('Error in inpute data')
  Else Begin
    BeginRadioImp:=StrToInt(BeginRadioImpStr);
    EndRadioImp:=StrToInt(EndRadioImpStr);
    FreqRadioImp:=StrToInt(FreqRadioImpStr);
    OffsetRadioImp:=StrToInt(OffsetRadioImpStr);
    MaxRadioImp:=StrToInt(MaxRadioImpStr);
    for i:=0 to BeginRadioImp do begin PatternArray[i]:=0;DACArray[i]:=OffsetRadioImp;end;
    for i:=BeginRadioImp to EndRadioImp do begin
      PatternArray[i]:=Round(MaxRadioImp*GeneratorSin(FreqRadioImp,i));
      DACArray[i]:=OffsetRadioImp+Round(MaxRadioImp*GeneratorSin(FreqRadioImp,i));
      if DACArray[i]<dac_minamp then DACArray[i]:=dac_minamp;
      if DACArray[i]>dac_maxamp then DACArray[i]:=dac_maxamp;
   end;
   for i:=(EndRadioImp+1) to ADCBufLen do begin PatternArray[i]:=0;DACArray[i]:=OffsetRadioImp;end;
 End;
end;

procedure TMainForm.GenerateRadioImpulseBurst;
var
  i,j,k,NachRadioPachka,DlitImpRadioPachka,
  PauseImpRadioPachka,
  KolImpRadioPachka,
  FreqRadioPachka : longint;
  OffsetImpRadioPachka,
  MaxAmplImpRadioPachka : smallint;
  NachRadioPachkaStr,DlitImpRadioPachkaStr,
  PauseImpRadioPachkaStr,
  FreqRadioPachkaStr,
  KolImpRadioPachkaStr,
  OffsetImpRadioPachkaStr,
  MaxAmplImpRadioPachkaStr : string;
begin
  NachRadioPachkaStr:=Trim(RadioImpulseBurstSignalBeginEdit.Text);
  DlitImpRadioPachkaStr:=Trim(RadioImpulseBurstImpulseLengthEdit.Text);
  PauseImpRadioPachkaStr:=Trim(RadioImpulseBurstBetwenImpulsesEdit.Text);
  KolImpRadioPachkaStr:=Trim(RadioImpulseBurstImpulsesNumberEdit.Text);
  OffsetImpRadioPachkaStr:=Trim(RadioImpulseBurstSignalOffsetEdit.Text);
  MaxAmplImpRadioPachkaStr:=Trim(RadioImpulseBurstSignalAmplifireEdit.Text);
  FreqRadioPachkaStr:=Trim(RadioImpulseBurstFrequencyEdit.Text);

  if (NachRadioPachkaStr='') or (DlitImpRadioPachkaStr='') or
     (PauseImpRadioPachkaStr='') or (KolImpRadioPachkaStr='') or
     (OffsetImpRadioPachkaStr='') or (OffsetImpRadioPachkaStr='')
     or (FreqRadioPachkaStr='') then   ShowMessage('Error in inpute data')
  else begin
    NachRadioPachka:=StrToInt(NachRadioPachkaStr);
    DlitImpRadioPachka:=StrToInt(DlitImpRadioPachkaStr);
    PauseImpRadioPachka:=StrToInt(PauseImpRadioPachkaStr);
    KolImpRadioPachka:=StrToInt(KolImpRadioPachkaStr);
    OffsetImpRadioPachka:=StrToInt(OffsetImpRadioPachkaStr);
    MaxAmplImpRadioPachka:=StrToInt(MaxAmplImpRadioPachkaStr);
    FreqRadioPachka:=StrToInt(FreqRadioPachkaStr);

    for i:=0 to NachRadioPachka do begin PatternArray[i]:=0;DACArray[i]:=OffsetImpRadioPachka;end;//0;

    k:=NachRadioPachka;
    for j:=1 to KolImpRadioPachka do begin
      for i:=k to k+DlitImpRadioPachka-1 do begin
        PatternArray[i]:=Round(MaxAmplImpRadioPachka*GeneratorSin(FreqRadioPachka,i));
        DACArray[i]:=OffsetImpRadioPachka+Round(MaxAmplImpRadioPachka*GeneratorSin(FreqRadioPachka,i));
        if DACArray[i]<dac_minamp then DACArray[i]:=dac_minamp;
        if DACArray[i]>dac_maxamp then DACArray[i]:=dac_maxamp;
      end;
      k:=k+DlitImpRadioPachka;
      for i:=k to k+PauseImpRadioPachka-1 do begin PatternArray[i]:=0;DACArray[i]:=OffsetImpRadioPachka;end;//0;
      k:=k+PauseImpRadioPachka;
    end;
    for i:=k to ADCBufLen do begin PatternArray[i]:=0;DACArray[i]:=OffsetImpRadioPachka;end;//0;
  end
end;

procedure TMainForm.GenerateLCHMImpulse;
var
  NachLCHMImpStr,
  DlitLCHMImpStr,
  NachLCHMImpFreqStr,
  EndLCHMImpFreqStr,
  AmplLCHMImpStr,
  OffsetLCHMImpStr: string;
  i,
  NachLCHMImp,
  DlitLCHMImp,
  NachLCHMImpFreq,
  EndLCHMImpFreq : longint;
  AmplLCHMImp,
  OffsetLCHMImp : smallint;
  SpeedFreq,CurrentTime : extended;
begin
  NachLCHMImpStr:=Trim(LCHMImpulseSignalBeginEdit.Text);
  DlitLCHMImpStr:=Trim(LCHMImpulseImpulseLengthEdit.Text);
  NachLCHMImpFreqStr:=Trim(LCHMImpulseBeginFrequencyEdit.Text);
  EndLCHMImpFreqStr:=Trim(LCHMImpulseEndFrequencyEdit.Text);
  AmplLCHMImpStr:=Trim(LCHMImpulseSignalAmplifireEdit.Text);
  OffsetLCHMImpStr:=Trim(LCHMImpulseSignalOffsetEdit.Text);

  if (NachLCHMImpStr='') or (DlitLCHMImpStr='') or
     (NachLCHMImpFreqStr='') or (EndLCHMImpFreqStr='') or
     (AmplLCHMImpStr='') or  (OffsetLCHMImpStr='') then ShowMessage('Error in inpute data')
  else begin
    NachLCHMImp:=StrToInt(NachLCHMImpStr);
    DlitLCHMImp:=StrToInt(DlitLCHMImpStr);
    NachLCHMImpFreq:=StrToInt(NachLCHMImpFreqStr);
    EndLCHMImpFreq:=StrToInt(EndLCHMImpFreqStr);
    AmplLCHMImp:=StrToInt(AmplLCHMImpStr);
    OffsetLCHMImp:=StrToInt(OffsetLCHMImpStr);

    SpeedFreq:=(EndLCHMImpFreq-NachLCHMImpFreq)/DlitLCHMImp;

    for i:=0 to NachLCHMImp do begin PatternArray[i]:=0;DACArray[i]:= OffsetLCHMImp;end;//0;

    for i:=NachLCHMImp to NachLCHMImp+DlitLCHMImp-1 do begin
      CurrentTime:=(i-NachLCHMImp)/FREQDISCRETE_HZ;
      PatternArray[i]:=Round(AmplLCHMImp*sin(2*Pi*(NachLCHMImpFreq+
      SpeedFreq*(i-NachLCHMImp))*CurrentTime));
      DACArray[i]:=OffsetLCHMImp+Round(AmplLCHMImp*sin(2*Pi*(NachLCHMImpFreq+
      SpeedFreq*(i-NachLCHMImp))*CurrentTime));
      if DACArray[i]<dac_minamp then DACArray[i]:=dac_minamp;
      if DACArray[i]>dac_maxamp then DACArray[i]:=dac_maxamp;
    end;

    for i:=NachLCHMImp+DlitLCHMImp to ADCBufLen do begin PatternArray[i]:=0;DACArray[i]:=OffsetLCHMImp;end;//0;
  end
end;

procedure TMainForm.GenerateBarkerCode;
var
  BeginBarkerStr,FreqCarierStr,NumberPeriodStr,
  OffsetBarkerStr,AmplitudeBarkerStr : string;
  i,CountPosition,CountSamples,
  BeginBarker,FreqCarier,NumberPosition,NumberPeriod,
  OffsetBarker,AmplitudeBarker   :  longint;
  BarkerPosition : array[1..13] of integer;
  {DlitBarker,}CurrentTime : extended;
begin
  NumberPosition:=0;
  case BarkerPositionNumberComboBox.ItemIndex of
  {13} 0 :begin
          NumberPosition:=13;
          BarkerPosition[1]:=1;BarkerPosition[2]:=1;BarkerPosition[3]:=1;
          BarkerPosition[4]:=1;BarkerPosition[5]:=1;BarkerPosition[6]:=-1;
          BarkerPosition[7]:=-1;BarkerPosition[8]:=1;BarkerPosition[9]:=1;
          BarkerPosition[10]:=-1;BarkerPosition[11]:=1;BarkerPosition[12]:=-1;
          BarkerPosition[13]:=1;
          end;
  {11} 1 :begin
          NumberPosition:=11;
          BarkerPosition[1]:=1;BarkerPosition[2]:=1;BarkerPosition[3]:=1;
          BarkerPosition[4]:=-1;BarkerPosition[5]:=-1;BarkerPosition[6]:=-1;
          BarkerPosition[7]:=1;BarkerPosition[8]:=-1;BarkerPosition[9]:=-1;
          BarkerPosition[10]:=1;BarkerPosition[11]:=-1;BarkerPosition[12]:=0;
          BarkerPosition[13]:=0;
          end;
  {7}  2 :begin
          NumberPosition:=7;
          BarkerPosition[1]:=1;BarkerPosition[2]:=1;BarkerPosition[3]:=1;
          BarkerPosition[4]:=-1;BarkerPosition[5]:=-1;BarkerPosition[6]:=1;
          BarkerPosition[7]:=-1;BarkerPosition[8]:=0;BarkerPosition[9]:=0;
          BarkerPosition[10]:=0;BarkerPosition[11]:=0;BarkerPosition[12]:=0;
          BarkerPosition[13]:=0;
          end;
  {5}  3 :begin
          NumberPosition:=5;
          BarkerPosition[1]:=1;BarkerPosition[2]:=1;BarkerPosition[3]:=1;
          BarkerPosition[4]:=-1;BarkerPosition[5]:=1;BarkerPosition[6]:=0;
          BarkerPosition[7]:=0;BarkerPosition[8]:=0;BarkerPosition[9]:=0;
          BarkerPosition[10]:=0;BarkerPosition[11]:=0;BarkerPosition[12]:=0;
          BarkerPosition[13]:=0;
          end;
  {3}  4 :begin
          NumberPosition:=3;
          BarkerPosition[1]:=1;BarkerPosition[2]:=1;BarkerPosition[3]:=-1;
          BarkerPosition[4]:=0;BarkerPosition[5]:=0;BarkerPosition[6]:=0;
          BarkerPosition[7]:=0;BarkerPosition[8]:=0;BarkerPosition[9]:=0;
          BarkerPosition[10]:=0;BarkerPosition[11]:=0;BarkerPosition[12]:=0;
          BarkerPosition[13]:=0;
          end;
  end{case};

  BeginBarkerStr:=Trim(BarkerSignalBeginEdit.Text);
  FreqCarierStr:=Trim(BarkerFrequencyEdit.Text);
  NumberPeriodStr:=Trim(BarkerPeriodByPositionEdit.Text);
  OffsetBarkerStr:=Trim(BarkerSignalOffsetEdit.Text);
  AmplitudeBarkerStr:=Trim(BarkerSignalAmplifireEdit.Text);

  if (BeginBarkerStr='') or (FreqCarierStr='') or
     (NumberPeriodStr='') or   (OffsetBarkerStr='') or
     (AmplitudeBarkerStr='') then ShowMessage('Error in inpute data')
  else begin
    BeginBarker:=StrToInt(BeginBarkerStr);
    FreqCarier:=StrToInt(FreqCarierStr);
    NumberPeriod:=StrToInt(NumberPeriodStr);
    OffsetBarker:=StrToInt(OffsetBarkerStr);
    AmplitudeBarker:=StrToInt(AmplitudeBarkerStr);

    for i:=0 to BeginBarker do
    begin
      PatternArray[i]:=0;
      DACArray[i]:= OffsetBarker;
    end;//0;

    //DlitBarker:=NumberPosition*NumberPeriod/FreqCarier;
    CountSamples:=BeginBarker;
    CountPosition:=1;
    CurrentTime:=(CountSamples-BeginBarker)/FREQDISCRETE_HZ;

    while CountPosition<=NumberPosition do begin
      if BarkerPosition[CountPosition]=1 then begin
        PatternArray[CountSamples]:=Round(AmplitudeBarker*sin(2*Pi*FreqCarier*CurrentTime));
        DACArray[CountSamples]:=OffsetBarker+Round(AmplitudeBarker*sin(2*Pi*FreqCarier*CurrentTime));
      end;
      if BarkerPosition[CountPosition]=-1 then begin
        PatternArray[CountSamples]:=Round(AmplitudeBarker*sin(2*Pi*FreqCarier*CurrentTime+pi));
        DACArray[CountSamples]:=OffsetBarker+Round(AmplitudeBarker*sin(2*Pi*FreqCarier*CurrentTime+pi));
      end;
      if DACArray[CountSamples]<dac_minamp then DACArray[CountSamples]:=dac_minamp;
      if DACArray[CountSamples]>dac_maxamp then DACArray[CountSamples]:=dac_maxamp;

      inc(CountSamples);
      CurrentTime:=(CountSamples-BeginBarker)/FREQDISCRETE_HZ;
      CountPosition:= Floor(CurrentTime * FreqCarier/NumberPeriod) +1;
    end;
    for i:=CountSamples to ADCBufLen do begin PatternArray[i]:=0;DACArray[i]:=OffsetBarker;end;//0;
  end
end;

procedure TMainForm.Channel1RadioButtonClick(Sender: TObject);
begin
  UpdateSignalScreen;
  FlipToScr;
end;

procedure TMainForm.Channel2RadioButtonClick(Sender: TObject);
begin
  UpdateSignalScreen;
  FlipToScr;
end;

procedure TMainForm.Channel12RadioButtonClick(Sender: TObject);
begin
  UpdateSignalScreen;
  FlipToScr;
end;

Procedure TMainForm.ChannelSubRadioButtonClick(Sender: TObject);
Begin
  UpdateSignalScreen;
  FlipToScr;
End;

Procedure TMainForm.CalculateStatistic;
Var
  i,i_from,i_to:integer;
  ChnValue:DWord; Chn1Value:Real; Chn2Value:Real;
Begin
  For i:=0 To 13 Do Begin
    Chn1[i]:=0; Chn2[i]:=0;
  End;
  Chn1ZeroLevel:=0;
  Chn2ZeroLevel:=0;
  Chn1Shum:=0;
  Chn2Shum:=0;

  If InputDataInActiveBankCheckBox.Checked Then Begin
    i_from:=ActiveBank*BankLen+BankOffset;
    i_to:=(ActiveBank+1)*BankLen+BankOffset;
  End Else Begin
    i_from:=0;
    i_to:=ADCBufLen;
  End;

  For i:=i_from To i_to Do Begin
    ChnValue:=Trunc(RealDataArray_Chn0[i]);
    If (ChnValue And 1)   <> 0 Then Inc(Chn1[0]);
    If (ChnValue And 2)   <> 0 Then Inc(Chn1[1]);
    If (ChnValue And 4)   <> 0 Then Inc(Chn1[2]);
    If (ChnValue And 8)   <> 0 Then Inc(Chn1[3]);
    If (ChnValue And 16)  <> 0 Then Inc(Chn1[4]);
    If (ChnValue And 32)  <> 0 Then Inc(Chn1[5]);
    If (ChnValue And 64)  <> 0 Then Inc(Chn1[6]);
    If (ChnValue And 128) <> 0 Then Inc(Chn1[7]);
    If (ChnValue And 256) <> 0 Then Inc(Chn1[8]);
    If (ChnValue And 512) <> 0 Then Inc(Chn1[9]);
    If (ChnValue And 1024)<> 0 Then Inc(Chn1[10]);
    If (ChnValue And 2048)<> 0 Then Inc(Chn1[11]);
    If (ChnValue And 4096)<> 0 Then Inc(Chn1[12]);
    If (ChnValue And 8192)<> 0 Then Inc(Chn1[13]);
    ChnValue:=Trunc(RealDataArray_Chn1[i]);
    If (ChnValue And 1)   <> 0 Then Inc(Chn2[0]);
    If (ChnValue And 2)   <> 0 Then Inc(Chn2[1]);
    If (ChnValue And 4)   <> 0 Then Inc(Chn2[2]);
    If (ChnValue And 8)   <> 0 Then Inc(Chn2[3]);
    If (ChnValue And 16)  <> 0 Then Inc(Chn2[4]);
    If (ChnValue And 32)  <> 0 Then Inc(Chn2[5]);
    If (ChnValue And 64)  <> 0 Then Inc(Chn2[6]);
    If (ChnValue And 128) <> 0 Then Inc(Chn2[7]);
    If (ChnValue And 256) <> 0 Then Inc(Chn2[8]);
    If (ChnValue And 512) <> 0 Then Inc(Chn2[9]);
    If (ChnValue And 1024)<> 0 Then Inc(Chn2[10]);
    If (ChnValue And 2048)<> 0 Then Inc(Chn2[11]);
    If (ChnValue And 4096)<> 0 Then Inc(Chn2[12]);
    If (ChnValue And 8192)<> 0 Then Inc(Chn2[13]);

    Chn1ZeroLevel:=Chn1ZeroLevel+RealDataArray_Chn0[i];
    Chn2ZeroLevel:=Chn2ZeroLevel+RealDataArray_Chn1[i];
  End;

  Chn1ZeroLevel:=Chn1ZeroLevel/(i_to-i_from+1);
  Chn2ZeroLevel:=Chn2ZeroLevel/(i_to-i_from+1);

  For i:=i_from To i_to Do Begin
    Chn1Value:=RealDataArray_Chn0[i];
    Chn2Value:=RealDataArray_Chn1[i];

    Chn1Shum:=Chn1Shum+(Chn1Value-Chn1ZeroLevel)*(Chn1Value-Chn1ZeroLevel);
    Chn2Shum:=Chn2Shum+(Chn2Value-Chn2ZeroLevel)*(Chn2Value-Chn2ZeroLevel);
  End;

  Chn1Shum:=Sqrt(Chn1Shum/(i_to-i_from+1));
  Chn2Shum:=Sqrt(Chn2Shum/(i_to-i_from+1));

  AveChn1Bit0ValueLabel.Caption  := IntToStr(Chn1[0]);
  AveChn1Bit1ValueLabel.Caption  := IntToStr(Chn1[1]);
  AveChn1Bit2ValueLabel.Caption  := IntToStr(Chn1[2]);
  AveChn1Bit3ValueLabel.Caption  := IntToStr(Chn1[3]);
  AveChn1Bit4ValueLabel.Caption  := IntToStr(Chn1[4]);
  AveChn1Bit5ValueLabel.Caption  := IntToStr(Chn1[5]);
  AveChn1Bit6ValueLabel.Caption  := IntToStr(Chn1[6]);
  AveChn1Bit7ValueLabel.Caption  := IntToStr(Chn1[7]);
  AveChn1Bit8ValueLabel.Caption  := IntToStr(Chn1[8]);
  AveChn1Bit9ValueLabel.Caption  := IntToStr(Chn1[9]);
  AveChn1Bit10ValueLabel.Caption := IntToStr(Chn1[10]);
  AveChn1Bit11ValueLabel.Caption := IntToStr(Chn1[11]);
  AveChn1Bit12ValueLabel.Caption := IntToStr(Chn1[12]);
  AveChn1Bit13ValueLabel.Caption := IntToStr(Chn1[13]);

  AveChn2Bit0ValueLabel.Caption  := IntToStr(Chn2[0]);
  AveChn2Bit1ValueLabel.Caption  := IntToStr(Chn2[1]);
  AveChn2Bit2ValueLabel.Caption  := IntToStr(Chn2[2]);
  AveChn2Bit3ValueLabel.Caption  := IntToStr(Chn2[3]);
  AveChn2Bit4ValueLabel.Caption  := IntToStr(Chn2[4]);
  AveChn2Bit5ValueLabel.Caption  := IntToStr(Chn2[5]);
  AveChn2Bit6ValueLabel.Caption  := IntToStr(Chn2[6]);
  AveChn2Bit7ValueLabel.Caption  := IntToStr(Chn2[7]);
  AveChn2Bit8ValueLabel.Caption  := IntToStr(Chn2[8]);
  AveChn2Bit9ValueLabel.Caption  := IntToStr(Chn2[9]);
  AveChn2Bit10ValueLabel.Caption := IntToStr(Chn2[10]);
  AveChn2Bit11ValueLabel.Caption := IntToStr(Chn2[11]);
  AveChn2Bit12ValueLabel.Caption := IntToStr(Chn2[12]);
  AveChn2Bit13ValueLabel.Caption := IntToStr(Chn2[13]);

  StatisticChannel1ZeroLevelEdit.Text:=FormatFloat('0.0000',Chn1ZeroLevel);
  StatisticChannel2ZeroLevelEdit.Text:=FormatFloat('0.0000',Chn2ZeroLevel);
  StatisticChannel1NoiseLevelEdit.Text:=FormatFloat('0.0000',Chn1Shum);
  StatisticChannel2NoiseLevelEdit.Text:=FormatFloat('0.0000',Chn2Shum);
End;

procedure TMainForm.ClearHistograms;
var i:Integer;
begin
  For i:=0 To Hist1BarsNum-1 Do Hist1BarsValues[i]:=0;
  For i:=0 To Hist2BarsNum-1 Do Hist2BarsValues[i]:=0;
end;

procedure TMainForm.DrawHistograms;
var
  i:Integer;
  stepx1,stepx2:Double;
  stepy1,stepy2:Double;
  hist1max,hist1min:Integer;
  hist2max,hist2min:Integer;
  x1,y1,x2,y2:Integer;
begin
  hist1max:=Hist1BarsValues[0];
  hist1min:=Hist1BarsValues[0];
  hist2max:=Hist2BarsValues[0];
  hist2min:=Hist2BarsValues[0];
  For i:=1 To Hist1BarsNum-1 Do Begin
    If Hist1BarsValues[i]>hist1max Then hist1max:=Hist1BarsValues[i];
    If Hist1BarsValues[i]<hist1min Then hist1min:=Hist1BarsValues[i];
  End;
  For i:=1 To Hist2BarsNum-1 Do Begin
    If Hist2BarsValues[i]>hist2max Then hist2max:=Hist2BarsValues[i];
    If Hist2BarsValues[i]<hist2min Then hist2min:=Hist2BarsValues[i];
  End;
  If (hist1max-hist1min)<>0 Then stepy1:=Hist1Box.Height/(hist1max-hist1min)
    Else stepy1:=1;
  If (hist2max-hist2min)<>0 Then stepy2:=Hist2Box.Height/(hist2max-hist2min)
    Else stepy2:=1;

  stepx1:=Hist1Box.Width/(Hist1BarsNum); stepx2:=Hist2Box.Width/(Hist2BarsNum);

  Hist1Box.Canvas.Brush.Color:=clWhite;
  Hist1Box.Canvas.FillRect(Rect(0,0,Hist1Box.Width,Hist1Box.Height));
  Hist1Box.Canvas.Pen.Color:=clBlack;
  Hist1Box.Canvas.Rectangle(Rect(0,0,Hist1Box.Width,Hist1Box.Height));
  Hist1Box.Canvas.Brush.Color:=clGreen;

  For i:=0 To Hist1BarsNum-1 Do Begin
    y1:=Hist1Box.Height; y2:=Trunc(Hist1Box.Height-Hist1BarsValues[i]*stepy1);
    x1:=Round(i*stepx1);
    x2:=Round(i*stepx1)+Round(stepx1);
    Hist1Box.Canvas.FillRect(Rect(x1,y1,x2,y2));
  End;

  Hist2Box.Canvas.Brush.Color:=clWhite;
  Hist2Box.Canvas.FillRect(Rect(0,0,Hist2Box.Width,Hist2Box.Height));
  Hist2Box.Canvas.Pen.Color:=clBlack;
  Hist2Box.Canvas.Rectangle(Rect(0,0,Hist2Box.Width,Hist2Box.Height));
  Hist2Box.Canvas.Brush.Color:=clGreen;

  Hist2Box.Canvas.Brush.Color:=clBlue;
  //x1:=0;
  For i:=0 To Hist2BarsNum-1 Do Begin
    y1:=Hist2Box.Height; y2:=Trunc(Hist2Box.Height-Hist2BarsValues[i]*stepy2);
    x1:=Round(i*stepx2);
    x2:=Round(i*stepx2)+Round(stepx2);
    Hist2Box.Canvas.FillRect(Rect(x1,y1,x2,y2));
  End;

  Histogram1PaintBox.Canvas.Draw(0,0,Hist1Box);
  Histogram2PaintBox.Canvas.Draw(0,0,Hist2Box);

  CalculateCountValueLabel.Caption:=IntToStr(HistMassCount);
end;

procedure TMainForm.CalcHistograms;
var
i,j,i_from,i_to:Integer;
begin
  If InputDataInActiveBankCheckBox.Checked Then Begin
    i_from:=ActiveBank*BankLen+BankOffset;
    i_to:=(ActiveBank+1)*BankLen+BankOffset;
  End Else Begin
    i_from:=0;
    i_to:=ADCBufLen;
  End;

  If InputDataNoiseRadioButton.Checked Then Begin
    i:=Trunc((Chn1Shum-Hist1ValueMin)/Hist1BarStepReal);
    If (i>=0)And(i<Hist1BarsNum) Then Inc(Hist1BarsValues[i]);
    i:=Trunc((Chn2Shum-Hist2ValueMin)/Hist2BarStepReal);
    If (i>=0)And(i<Hist2BarsNum) Then Inc(Hist2BarsValues[i]);
  End;
  If InputDataSignalRadioButton.Checked Then Begin
    For i:=i_from To i_to Do Begin
      j:=Trunc((RealDataArray_Chn0[i]-Hist1ValueMin)/Hist1BarStepReal);
      If (j>=0)And(j<Hist1BarsNum) Then Inc(Hist1BarsValues[j]);
      j:=Trunc((RealDataArray_Chn1[i]-Hist2ValueMin)/Hist2BarStepReal);
      If (j>=0)And(j<Hist2BarsNum) Then Inc(Hist2BarsValues[j]);
    End;
  End;
  Inc(HistMassCount);
end;


procedure TMainForm.CalculateHistogramCheckBoxClick(Sender: TObject);
begin
  ClearHistograms;
  HistMassCount:=0;
  Hist1BarsNum:=StrToInt(Histogram1BarsNumberEdit.Text);
  Hist2BarsNum:=StrToInt(Histogram2BarsNumberEdit.Text);
  Hist1ValueMin:=StrToFloat(Histogram1MinValueEdit.Text);
  Hist1ValueMax:=StrToFloat(Histogram1MaxValueEdit.Text);
  Hist2ValueMin:=StrToFloat(Histogram2MinValueEdit.Text);
  Hist2ValueMax:=StrToFloat(Histogram2MaxValueEdit.Text);

  Hist1BarStep:=Trunc((Hist1ValueMax-Hist1ValueMin)/Hist1BarsNum);
  Hist1BarStepReal:=(Hist1ValueMax-Hist1ValueMin)/Hist1BarsNum;
  Hist2BarStep:=Trunc((Hist2ValueMax-Hist2ValueMin)/Hist2BarsNum);
  Hist2BarStepReal:=(Hist2ValueMax-Hist2ValueMin)/Hist2BarsNum;

  If InputDataSignalRadioButton.Checked Then Begin
    Histogram1CaptionLabel.Caption:='Histogram 1 (Signal - Channel 1)';
    Histogram2CaptionLabel.Caption:='Histogram 2 (Signal - Channel 2)';
  End Else Begin
    Histogram1CaptionLabel.Caption:='Histogram 1 (Noise Level - Channel 1)';
    Histogram2CaptionLabel.Caption:='Histogram 2 (Noise Level - Channel 2)';
  End;
end;

procedure TMainForm.ClearHistogrammsButtonClick(Sender: TObject);
begin
  ClearHistograms;
  HistMassCount:=0;
end;

procedure TMainForm.Histogram1PaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var
bar:Integer;
a,b:Double;
stepx:Double;
begin
  stepx:=Hist1Box.Width/Hist1BarsNum;
  bar:=Trunc(X/stepx);
  a:=Hist1ValueMin+bar*Hist1BarStepReal;
  b:=Hist1ValueMin+(bar+1)*Hist1BarStepReal;
  Histogram1RangeValueLabel.Caption:=FormatFloat('0.####',a)+'...'+FormatFloat('0.####',b)+'   '+IntToStr(Hist1BarsValues[bar]);
end;

procedure TMainForm.Histogram2PaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var
bar:Integer;
a,b:Double;
stepx:Double;
begin
  stepx:=Hist2Box.Width/Hist2BarsNum;
  bar:=Trunc(X/stepx);
  a:=Hist2ValueMin+bar*Hist2BarStepReal;
  b:=Hist2ValueMin+(bar+1)*Hist2BarStepReal;
  Histogram2RangeValueLabel.Caption:=FormatFloat('0.####',a)+'...'+FormatFloat('0.####',b)+'   '+IntToStr(Hist2BarsValues[bar]);
end;


procedure TMainForm.SignalPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var pos,pos1:Integer;
begin
  pos:=Round((X-sx1)/_stepx);

  Case SignalsPageControl.ActivePageIndex Of
    0:Begin
        If pos>BankLen-1 Then pos:=BankLen-1;
        If pos<0 Then pos:=0;
        pos:=BankLen*ActiveBank+_offset+pos+BankOffset;
        If Channel1RadioButton.Checked Then
        Status1Label.Caption:='POS:'+IntToStr(pos)+'  AMP:'+FormatFloat('0',RealDataArray_Chn0[pos])
        Else If Channel2RadioButton.Checked Then
        Status1Label.Caption:='POS:'+IntToStr(pos)+'  AMP:'+FormatFloat('0',RealDataArray_Chn1[pos])
        Else If Channel12RadioButton.Checked Then
        Status1Label.Caption:='POS:'+IntToStr(pos)+'  AMP1:'+FormatFloat('0',RealDataArray_Chn0[pos])+'  AMP2:'+FormatFloat('0',RealDataArray_Chn1[pos])
        Else If ChannelSubRadioButton.Checked Then
        Status1Label.Caption:='POS:'+IntToStr(pos)+'  AMP:'+FormatFloat('0',RealDataArray_Chn0[pos]);
      End;
    1:Begin
        If pos>DACBankLen-1 Then pos:=DACBankLen-1;
        If pos<0 Then pos:=0;
        pos:=DACBankLen*DACActiveBank+_offset+pos+BankOffset;
        Status1Label.Caption:='POS:'+IntToStr(pos)+'  AMP:'+FormatFloat('0',DACArray[pos]);
      End;
  End;
  If Zoom_Allow And Zoom_BeginDrag Then Begin
    If (X>=sx1)And(X<=sx2) Then Begin
    Zoom_X2:=X;
    UpdateScreen;
    FlipToScr;
    End;
  End;
end;

procedure TMainForm.AutoScaleCheckBoxClick(Sender: TObject);
begin
  UpdateSignalScreen;
  FlipToScr;
end;

procedure TMainForm.SignalPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If (Zoom_Allow)And(X>=sx1)And(X<=sx2) Then Begin
  Zoom_X1:=X; Zoom_X2:=X;
  Zoom_BeginDrag:=True;
  UpdateScreen;
  FlipToScr;
  End;
end;

procedure TMainForm.SignalPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var pos1,pos2:Integer; banklen_:Integer;
begin
  If Zoom_Allow Then Begin
  Zoom_BeginDrag:=False;

  pos1:=Round((Zoom_X1-sx1)/_stepx);
  pos2:=Round((Zoom_X2-sx1)/_stepx);
  banklen_:=pos2-pos1+1;

  //Label1.Caption:=IntToStr(pos1)+' '+IntToStr(pos2);

  If banklen_>1 Then
  Case SignalsPageControl.ActivePageIndex Of
    0:Begin
        pos1:=ActiveBank*BankLen+_offset+BankOffset+pos1;
        BankLen:=banklen_;
        ActiveBank:=(pos1 div BankLen)+1;
        BankOffset:=pos1-(ActiveBank*BankLen+_offset);
        ActiveBankLabel.Caption:=IntToStr(ActiveBank);
        ViewBankScrollBar.Max:=(XDSP_BOARD_MEMORY div BankLen)-1;
        ViewBankScrollBar.Position:=ActiveBank;
        BankSizeComboBox.Text:=IntToStr(BankLen);
      End;
    1:Begin
        pos1:=DACActiveBank*DACBankLen+BankOffset+pos1;
        DACBankLen:=banklen_;
        DACActiveBank:=(pos1 div DACBankLen);
        BankOffset:=pos1-DACActiveBank*DACBankLen;
        DACActiveBankLabel.Caption:=IntToStr(DACActiveBank);
        DACViewBankScrollBar.Max:=(XDSP_BOARD_MEMORY div DACBankLen)-1;
        DACViewBankScrollBar.Position:=DACActiveBank;
        DACBankSizeComboBox.Text:=IntToStr(DACBankLen);
      End;
  End;
  UpdateScreen;
  FlipToScr;
  End;
end;

procedure TMainForm.FileSaveClick(Sender: TObject);
Var
  f:TextFile;
  i:Integer;
  dwData:DWORD;
begin
  Zoom_Allow:=False;
  If SaveDialog.Execute Then Begin
    AssignFile(f,SaveDialog.FileName);
    ReWrite(f);

    Case SignalsPageControl.ActivePageIndex Of
    0:For i:=0 To ADCBufLen Do Begin
        If Channel1RadioButton.Checked Then WriteLn(f,FloatToStr(RealDataArray_Chn0[i]));
        If Channel2RadioButton.Checked Then WriteLn(f,FloatToStr(RealDataArray_Chn1[i]));
        If Channel12RadioButton.Checked Then WriteLn(f,FloatToStr(RealDataArray_Chn0[i]),' ',FloatToStr(RealDataArray_Chn1[i]));
        If ChannelSubRadioButton.Checked Then WriteLn(f,FloatToStr(RealDataArray_Chn0[i]),' ',FloatToStr(RealDataArray_Chn1[i]));
      End;
    1:For i:=0 To ADCBufLen Do WriteLn(f,FormatFloat('0',DACArray[i]));
    End;{Case}

    CloseFile(f);
    UpdateScreen;
  End;

  Zoom_Allow:=True;
end;

procedure TMainForm.FileLoadClick(Sender: TObject);
Var f:TextFile; i:Integer;
begin
  Zoom_Allow:=False;
  If OpenDialog.Execute Then Begin
    AssignFile(f,OpenDialog.FileName);
    Reset(f);
    Case SignalsPageControl.ActivePageIndex Of
    0:For i:=0 To ADCBufLen Do Begin
        If Channel1RadioButton.Checked Then BEGIN ReadLn(f,RealDataArray_Chn0[i]) END;
        If Channel2RadioButton.Checked Then ReadLn(f,RealDataArray_Chn1[i]);
        If Channel12RadioButton.Checked Then ReadLn(f,RealDataArray_Chn0[i],RealDataArray_Chn1[i]);
        If ChannelSubRadioButton.Checked Then ReadLn(f,RealDataArray_Chn0[i],RealDataArray_Chn1[i]);
      End;
    1:For i:=0 To ADCBufLen Do ReadLn(f,DACArray[i]);
    End;{Case}
  End;
  CloseFile(f);
  UpdateScreen;
  Zoom_Allow:=True;
end;

procedure TMainForm.FileCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.BankOffsetRightButtonClick(Sender: TObject);
begin  Case SignalsPageControl.ActivePageIndex Of
    0,1,2:Begin
        BankOffset:=BankOffset+1;
        If ActiveBank*BankLen+_offset+BankOffset>ADCBufLen Then BankOffset:=BankOffset-1;
        UpdateScreen;
        FlipToScr;
      End;
    4:Begin
        BankOffset:=BankOffset+1;
        If FFTActiveBank*FFTBankLen+_offset+BankOffset>FFTPointsNumber Then BankOffset:=BankOffset-1;
        UpdateScreen;
        FlipToScr;
      End;
  End;
end;

procedure TMainForm.BankOffsetLeftButtonClick(Sender: TObject);
begin
  Case SignalsPageControl.ActivePageIndex Of
    0,1,2,4:Begin
        BankOffset:=BankOffset-1;
        If ActiveBank*BankLen+_offset+BankOffset<0 Then BankOffset:=BankOffset+1;
        UpdateScreen;
        FlipToScr;
      End;
  End;
end;

procedure TMainForm.BankOffsetRight10ButtonClick(Sender: TObject);
begin
  Case SignalsPageControl.ActivePageIndex Of
    0,1,2:Begin
        BankOffset:=BankOffset+10;
        If ActiveBank*BankLen+_offset+BankOffset>ADCBufLen Then BankOffset:=BankOffset-10;
        UpdateScreen;
        FlipToScr;
      End;
    4:Begin
        BankOffset:=BankOffset+10;
        If FFTActiveBank*FFTBankLen+_offset+BankOffset>FFTPointsNumber Then BankOffset:=BankOffset-10;
        UpdateScreen;
        FlipToScr;
      End;
  End;
end;

procedure TMainForm.BankOffsetLeft10ButtonClick(Sender: TObject);
begin
  Case SignalsPageControl.ActivePageIndex Of
    0,1,2,4:Begin
        BankOffset:=BankOffset-10;
        If ActiveBank*BankLen+_offset+BankOffset<0 Then BankOffset:=BankOffset+10;
        UpdateScreen;
        FlipToScr;
      End;
  End;
end;

procedure TMainForm.ClearBankOffsetButtonClick(Sender: TObject);
begin
  BankOffset:=0;
  BankOffsetLabel.Caption:=IntToStr(BankOffset);
  UpdateScreen;
  FlipToScr;
end;

procedure TMainForm.SignalScaleLowButtonClick(Sender: TObject);
begin
  SignalScaleYCoefficient:=SignalScaleYCoefficient-1;
  If SignalScaleYCoefficient<0.1 Then SignalScaleYCoefficient:=0.1;
  Status1Label.Caption:='Scale Y Coefficient = '+FloatToStr(SignalScaleYCoefficient);
end;

procedure TMainForm.SignalScaleLow1ButtonClick(Sender: TObject);
begin
  SignalScaleYCoefficient:=SignalScaleYCoefficient-0.1;
  If SignalScaleYCoefficient<0.1 Then SignalScaleYCoefficient:=0.1;
  Status1Label.Caption:='Scale Y Coefficient = '+FloatToStr(SignalScaleYCoefficient);
end;

procedure TMainForm.SignalScaleHighButtonClick(Sender: TObject);
begin
  SignalScaleYCoefficient:=SignalScaleYCoefficient+0.1;
  Status1Label.Caption:='Scale Y Coefficient = '+FloatToStr(SignalScaleYCoefficient);
end;

procedure TMainForm.SignalScaleHigh1ButtonClick(Sender: TObject);
begin
  SignalScaleYCoefficient:=SignalScaleYCoefficient+1;
  Status1Label.Caption:='Scale Y Coefficient = '+FloatToStr(SignalScaleYCoefficient);
end;

procedure TMainForm.FrequencyDividerButtonClick(Sender: TObject);
var i : integer;
begin
for i:=1 to dev_count do
  XdspSetSampleFrequencyDivider(XdspDevices[i].DeviceHandle,StrToInt(FrequencyDividerEdit.Text));
end;

procedure TMainForm.ExternalPuskEdgeCheckBoxClick(Sender: TObject);
var port_data:DWord;
i : integer;
begin
for i:=1 to dev_count do
  If ExternalPuskEdgeCheckBox.Checked Then XDSPSetNegEdgeExtStart(XdspDevices[i].DeviceHandle)
  Else XDSPSetPosEdgeExtStart(XdspDevices[i].DeviceHandle);
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  WriteToDAC(StrToInt(Edit1.Text));
end;

procedure TMainForm.Button1Click(Sender: TObject);
var i:Integer;
begin
  For i:=0 To 4095 Do WriteToDAC(i);
end;

procedure TMainForm.SetDACDefaultValueButtonClick(Sender: TObject);
var
DAC1DefaultValue,DAC2DefaultValue : Dword;
j : integer;

begin

  If (DAC1DefaultValueEdit.Text='')  Then
      ShowMessage('Error in inpute DAC1 Default Value data')
  Else begin
      DAC1DefaultValue :=8192 - StrToInt(DAC1DefaultValueEdit.Text);//+dac_zerolevel;
      for j:=1 to dev_count do
         XDSPSetDAC1Default(XDspDevices[j].DeviceHandle,DAC1DefaultValue);
  end;


  If (DAC2DefaultValueEdit.Text='')  Then
      ShowMessage('Error in inpute DAC2 Default Value data')
  Else  begin
      DAC2DefaultValue :=8192 - StrToInt(DAC2DefaultValueEdit.Text);//+dac_zerolevel;
      for j:=1 to dev_count do
         XDSPSetDAC2Default(XDspDevices[j].DeviceHandle,DAC2DefaultValue);
  end;
end;

procedure TMainForm.HistBuffCheckBoxClick(Sender: TObject);
 var data : DWORD;
 i : integer;
begin
for i :=1 to dev_count do
  if HistBuffCheckBox.Checked=True then
     XDSPHistBuffEnable(XDspDevices[i].DeviceHandle)
  else
     XDSPHistBuffDisable(XDspDevices[i].DeviceHandle);
end;

procedure TMainForm.WriteToDAC(data_write : Word);
var
   mask_data : Word;
   i,j : integer;
begin

// XDSPWriteToADCDAC(X)
// 256  -> DAC3 SCLK
// 512  -> DAC3 Sync
// 1024 -> DAC3 Din

for i:=1 to dev_count do Begin

//Sync -> '1' clk -> '1'
XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,768,false,true);
//Sync -> '1' clk -> '0'
XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,512,false,true);
//Sync -> '1' clk -> '1'
XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,768,false,true);

mask_data := $8000;
//latch data (16 bit)
if (data_write and mask_data) = 0 then
   begin
      // latch data '0'
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,0,false,true);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,256,false,true);
   end
else
   begin
      //latch data '1'
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,1024,false,true);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,1280,false,true);
   end;

for j:= 15 downto 1 do
begin
   mask_data := mask_data shr 1;

   if (data_write and mask_data) = 0 then
   begin
      // latch data '0'
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,0,false,true);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,256,false,true);
   end
   else begin
      //latch data '1'
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,1024,false,true);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,1280,false,true);
   end;
end; //for

//Sync -> '1' clk -> '0'
XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,512,false,true);
//Sync -> '1' clk -> '1'
XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,768,false,true);
end; //for
end; // procedure

procedure TMainForm.WriteToAdC(data_write : Word; ADC1_enable : boolean; ADC2_enable : boolean);
var
   mask_data : Word;
   i,j : integer;
begin

for i:=1 to dev_count do Begin

///////// ADC1 adn ADC2 enable

if ((ADC1_enable=True) and (ADC2_enable=True)) then
begin

   //SEN -> '1' CLK ->'1'
   ADC_REG := ADC_REG or $0066;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0066);

   mask_data := $8000;
   if (data_write and mask_data) = 0 then
   begin
      // latch data '0'
      ADC_REG := ADC_REG or $0022;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 0
      ADC_REG := ADC_REG and (not $0022);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'0' data = 0
   end
   else begin
      //latch data '1'
      ADC_REG := ADC_REG or $00AA;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 1
      ADC_REG := ADC_REG and (not $00AA);
      ADC_REG := ADC_REG or $0088;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'0' data = 1
      ADC_REG := ADC_REG and (not $0088);
   end;

   for j:= 15 downto 1 do
   begin
      mask_data := mask_data shr 1;

      if (data_write and mask_data) = 0 then
      begin
         // latch data '0'
         ADC_REG := ADC_REG or $0022;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 0
         ADC_REG := ADC_REG and (not $0022);
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0000,true,false); //SEN -> '0' CLK ->'0' data = 0
      end
      else begin
         //latch data '1'
         ADC_REG := ADC_REG or $00AA;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 1
         ADC_REG := ADC_REG and (not $00AA);
         ADC_REG := ADC_REG or $0088;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'0' data = 1
         ADC_REG := ADC_REG and (not $0088);
      end;
   end; //for

   //SEN -> '1' CLK ->'1'
   ADC_REG := ADC_REG or $0066;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0066);
   //SEN -> '1' CLK ->'0'
   ADC_REG := ADC_REG or $0044;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0044);
end
else begin

////////// ADC1 only

if (ADC1_enable=True) then
begin
   //SEN -> '1' CLK ->'1'
   ADC_REG := ADC_REG or $0006;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0006);

   mask_data := $8000;
   if (data_write and mask_data) = 0 then
   begin
      // latch data '0'
      ADC_REG := ADC_REG or $0002;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 0
      ADC_REG := ADC_REG and (not $0002);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0000,true,false); //SEN -> '0' CLK ->'0' data = 0
   end
   else begin
      //latch data '1'
      ADC_REG := ADC_REG or $000A;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 1
      ADC_REG := ADC_REG and (not $000A);
      ADC_REG := ADC_REG or $0008;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'0' data = 1
      ADC_REG := ADC_REG and (not $0008);
   end;

   for j:= 15 downto 1 do
   begin
      mask_data := mask_data shr 1;

      if (data_write and mask_data) = 0 then
      begin
         // latch data '0'
         ADC_REG := ADC_REG or $0002;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 0
         ADC_REG := ADC_REG and (not $0002);
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0000,true,false); //SEN -> '0' CLK ->'0' data = 0
      end
      else begin
         //latch data '1'
         ADC_REG := ADC_REG or $000A;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 1
         ADC_REG := ADC_REG and (not $000A);
         ADC_REG := ADC_REG or $0008;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'0' data = 1
         ADC_REG := ADC_REG and (not $0008);
      end;
   end; //for

   //SEN -> '1' CLK ->'1'
   ADC_REG := ADC_REG or $0006;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0006);
   //SEN -> '1' CLK ->'0'
   ADC_REG := ADC_REG or $0004;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0004);
end;

////////// ADC2 only

if (ADC2_enable=True) then
begin
   //SEN -> '1' CLK ->'1'
   ADC_REG := ADC_REG or $0060;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0060);

   mask_data := $8000;
   if (data_write and mask_data) = 0 then
   begin
      // latch data '0'
      ADC_REG := ADC_REG or $0020;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 0
      ADC_REG := ADC_REG and (not $0020);
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0000,true,false); //SEN -> '0' CLK ->'0' data = 0
   end
   else begin
      //latch data '1'
      ADC_REG := ADC_REG or $00A0;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 1
      ADC_REG := ADC_REG and (not $00A0);
      ADC_REG := ADC_REG or $0080;
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'0' data = 1
      ADC_REG := ADC_REG and (not $0080);
   end;

   for j:= 15 downto 1 do
   begin
      mask_data := mask_data shr 1;

      if (data_write and mask_data) = 0 then
      begin
         // latch data '0'
         ADC_REG := ADC_REG or $0020;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 0
         ADC_REG := ADC_REG and (not $0020);
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,$0000,true,false); //SEN -> '0' CLK ->'0' data = 0
      end
      else begin
         //latch data '1'
         ADC_REG := ADC_REG or $00A0;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'1' data = 1
         ADC_REG := ADC_REG and (not $00A0);
         ADC_REG := ADC_REG or $0080;
         XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false); //SEN -> '0' CLK ->'0' data = 1
         ADC_REG := ADC_REG and (not $0080);
      end;
   end; //for

   //SEN -> '1' CLK ->'1'
   ADC_REG := ADC_REG or $0060;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0060);
   //SEN -> '1' CLK ->'0'
   ADC_REG := ADC_REG or $0040;
   XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
   ADC_REG := ADC_REG and (not $0040);
end;

end; //else
end; //for
end; // procedure

procedure TMainForm.CheckBox5Click(Sender: TObject);
var tmp_data : DWord;
i : integer;
begin
for i := 1 to dev_count do
  if (CheckBox5.Checked=True) then
     XDSPDACCounterEnable(XDspDevices[i].DeviceHandle)
  else
     XDSPDACCounterDisable(XDspDevices[i].DeviceHandle);
end; //procedure

procedure TMainForm.CheckBox6Click(Sender: TObject);
var tmp_data : DWord;
i : integer;
begin
for i:=1 to dev_count do
  if (CheckBox6.Checked=True) then
     XDSPDACtoADCEnable(XDspDevices[i].DeviceHandle)
  else
     XDSPDACtoADCDisable(XDspDevices[i].DeviceHandle);
end; //procedure

procedure TMainForm.ADC1normalRadioButtonClick(Sender: TObject);
var i : integer;
begin
   ADC_REG := ADC_REG and (not $1800);
   for i:=1 to dev_count do
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
end;

procedure TMainForm.ADC1ADCRadioButtonClick(Sender: TObject);
var i : integer;
begin
   ADC_REG := ADC_REG and (not $1800);
   ADC_REG := ADC_REG or $0800;
   for i:=1 to dev_count do
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
end;

procedure TMainForm.ADC1FIFORadioButtonClick(Sender: TObject);
var i : integer;
begin
   ADC_REG := ADC_REG and (not $1800);
   ADC_REG := ADC_REG or $1000;
   for i:=1 to dev_count do
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
end;

procedure TMainForm.ADC2normalRadioButtonClick(Sender: TObject);
var i : integer;
begin
   ADC_REG := ADC_REG and (not $6000);
   for i:=1 to dev_count do
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
end;

procedure TMainForm.ADC2ADCRadioButtonClick(Sender: TObject);
var i : integer;
begin
   ADC_REG := ADC_REG and (not $6000);
   ADC_REG := ADC_REG or $2000;
   for i:=1 to dev_count do
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
end;

procedure TMainForm.RadioButton6Click(Sender: TObject);
var i : integer;
begin
   ADC_REG := ADC_REG and (not $6000);
   ADC_REG := ADC_REG or $4000;
   for i:=1 to dev_count do
      XDSPWriteToADCDAC(XDspDevices[i].DeviceHandle,ADC_REG,true,false);
end;

procedure TMainForm.ADC1normalPatternRadioButtonClick(Sender: TObject);
begin
   WriteToADC($E000,true,false);
end;

procedure TMainForm.ADC1All0PatternRadioButtonClick(Sender: TObject);
begin
   WriteToADC($E200,true,false);
end;

procedure TMainForm.ADC1All1PatternRadioButtonClick(Sender: TObject);
begin
   WriteToADC($E400,true,false);
end;

procedure TMainForm.ADC1TogglesRadioButtonClick(Sender: TObject);
begin
   WriteToADC($E600,true,false);
end;

procedure TMainForm.ADC2normalPatternRadioButtonClick(Sender: TObject);
begin
   WriteToADC($E000,false,true);
end;

procedure TMainForm.ADC2All0PatternRadioButtonClick(Sender: TObject);
begin
   WriteToADC($E200,false,true);
end;

procedure TMainForm.ADC2All1PatternRadioButtonClick(Sender: TObject);
begin
   WriteToADC($E400,false,true);
end;

procedure TMainForm.ADC2TogglesRadioButtonClick(Sender: TObject);
begin
   WriteToADC($E600,false,true);
end;

procedure TMainForm.WriteDigOutData;
var temp : DWORD;
begin

temp := $00000000;

if DOUT0CheckBox.Checked then
   temp := temp or $00000002;

if DOUT1CheckBox.Checked then
   temp := temp or $00000004;

if DOUT2CheckBox.Checked then
   temp := temp or $00000008;

if DOUT3CheckBox.Checked then
   temp := temp or $00000010;

if DOUT4CheckBox.Checked then
   temp := temp or $00000020;

if DOUT5CheckBox.Checked then
   temp := temp or $00000040;

if XDSP_NotProcessFlag_TO_DOUT0CheckBox.Checked then
   temp := temp or $00000080;

if XDSP_ProcessFlag_TO_DOUT1CheckBox.Checked then
   temp := temp or $00000100;

if XDSP_ExtPuskEnable_TO_DOUT2CheckBox.Checked then
   temp := temp or $00000200;

if XDSP_NotExtPuskEnable_TO_DOUT3CheckBox.Checked then
   temp := temp or $00000400;

if XDSP_PCI_enable_TO_DOUT4CheckBox.Checked then
   temp := temp or $00000800;

if XDSP_NotPCI_enable_TO_DOUT5CheckBox.Checked then
   temp := temp or $00001000;

XDSPWriteDigOutData(XDspDevices[active_device].DeviceHandle,temp);

end;

procedure TMainForm.ReadDigInData;
var temp : DWORD;
begin

XDSPReadDigInData(XDspDevices[active_device].DeviceHandle,@temp);

if ((temp and $00000001) = 0) then
   DIN0CheckBox.Checked := false
else
   DIN0CheckBox.Checked := true;

if ((temp and $00000002) = 0) then
   DIN1CheckBox.Checked := false
else
   DIN1CheckBox.Checked := true;

if ((temp and $00000004) = 0) then
   DIN2CheckBox.Checked := false
else
   DIN2CheckBox.Checked := true;

if ((temp and $00000008) = 0) then
   DIN3CheckBox.Checked := false
else
   DIN3CheckBox.Checked := true;

if ((temp and $00000010) = 0) then
   DIN4CheckBox.Checked := false
else
   DIN4CheckBox.Checked := true;

if ((temp and $00000020) = 0 )then
   DIN5CheckBox.Checked := false
else
   DIN5CheckBox.Checked := true;

end;

procedure TMainForm.EnableDigExtStartCheckBoxClick(Sender: TObject);
begin
if EnableDigExtStartCheckBox.Checked then
   XDSPDigExtStartEnable(XDspDevices[active_device].DeviceHandle)
else
   XDSPDigExtStartDisable(XDspDevices[active_device].DeviceHandle);
end;

procedure TMainForm.Device1DevicesClick(Sender: TObject);
begin
     Device1Tab.PageIndex := 2;
     active_device := 2;
     Device0Devices.Checked:=false; Device1Devices.Checked:=true;
     Device2Devices.Checked:=false; Device3Devices.Checked:=false;
end;

procedure TMainForm.Device0DevicesClick(Sender: TObject);
begin
     Device0Tab.PageIndex := 1;
     active_device := 1;
     Device0Devices.Checked:=true; Device1Devices.Checked:=false;
     Device2Devices.Checked:=false; Device3Devices.Checked:=false;
end;

procedure TMainForm.Device2DevicesClick(Sender: TObject);
begin
     Device2Tab.PageIndex := 3;
     active_device := 3;
     Device0Devices.Checked:=false; Device1Devices.Checked:=false;
     Device2Devices.Checked:=true; Device3Devices.Checked:=false;
end;

procedure TMainForm.Device3DevicesClick(Sender: TObject);
begin
     Device3Tab.PageIndex := 4;
     active_device := 4;
     Device0Devices.Checked:=false; Device1Devices.Checked:=false;
     Device2Devices.Checked:=false; Device3Devices.Checked:=true;
end;


procedure TMainForm.Button3Click(Sender: TObject);
var i,j:Integer;
    Data,REG1 : DWord;

//    data1,data2,data3,data4 : integer;
//    errorRAM3,errorRAM4 : integer;
    status : integer;

begin
  SignalsPageControl.ActivePageIndex:=1;
  Refresh;
  UpdateScreen;
  FlipToScr;
  If Application.MessageBox('Load DAC Signal To XdspDevice DAC 1?','',[smbOK]+[smbCancel])=smbOK Then Begin
     for j:=1 to dev_count do Begin
       For i:=0 To ADCBufLen Do  XdspDevices[j].DMABuffer3^[i+1]:=8192 - Trunc(DACArray[i]);

       status := XDspStartWrite(XDspDevices[j].DeviceHandle,2,2,20000);

       if status <> 0 then ShowMessage('Not Load Signal To DAC1');

     end;
  End;

  If Application.MessageBox('Load DAC Signal To XdspDevice DAC2 ?','',[smbOK]+[smbCancel])=smbOK Then Begin
     for j:=1 to dev_count do Begin
       For i:=0 To ADCBufLen Do  XdspDevices[j].DMABuffer4^[i+1]:=8192 - Trunc(DACArray[i]);

       status := XDspStartWrite(XDspDevices[j].DeviceHandle,3,3,20000);

       if status <> 0 then ShowMessage('Not Load Signal To DAC2');
     end;
  End;
end;

End.//main
